////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

//make a userdata behavioral element
var tud = null;

function initCookie() {
  if (xopus_globs.browser.ie && !tud) {
    try {
      tud = xopus_globs.window.document.createElement("div");
      tud = xopus_globs.window.document.body.appendChild(tud);
      tud.id = 'xopus_cookiejar';
      tud.style.display = 'none';
      tud.addBehavior('#default#userData');
    } catch(e) {}
  }
}

function readUserData(theName, theDefault) {
  tud.load("Xopus");
  var theValue = tud.getAttribute(theName);
  if (theValue) return theValue;
  else return theDefault;
}

function writeUserData(theName, theValue) {
  tud.setAttribute(theName, theValue);
  try {
    tud.save("Xopus");
  } catch(e) {
    return false;
  }
  return true;
}

function readCookie(theName, theDefault) {
  try {
    //check if we can use cookies
    if (!xopus_globs.useCookies) return theDefault;

    initCookie();

    var ok = false;
    if (tud) {
      try {
        var theValue = readUserData(theName, theDefault);
        ok = true;
      } catch(e) {
        ok = false;
      }
    }

    if (!ok) {
      var theCookie = xopus_globs.document.cookie + "|;";
      var p = theCookie.indexOf("Xopus=");
      if (p == -1) return theDefault;
      theCookie = theCookie.substring(p, theCookie.indexOf("|;", p)) + "|";
      var pos = theCookie.indexOf(theName + ":");
      if (pos == -1) return theDefault;
      var theValue = unescape(theCookie.substring(pos+theName.length+1, theCookie.indexOf("|", pos)));
      if (theValue == "") return theDefault;
    }

    if (theValue == theDefault) return theDefault;
    else return castValue(theValue);
  } catch (e) {
    return theDefault;
  }
}

//function for writing a cookie or userdata
function writeCookie(theName, theValue) {
  try {
    //check if we can use cookies
    if (!xopus_globs.useCookies) return;

    initCookie();

    if (!tud || !writeUserData(theName, theValue)) {
      //get the cookie
      var theCookie = xopus_globs.document.cookie;

      //get the content of the cookie
      if (theCookie != "") var theContent = theCookie.substring(theCookie.indexOf("=") + 2, theCookie.length - 1);
      else var theContent = "";

      //split the content into name:value pairs
      var cArray = theContent.split("|");

      //make an associative name value array of them
      var nvs = new Object();
      for (var i=0; i<cArray.length; i++) {
        if (cArray[i].substring(0, cArray[i].indexOf(":")) != "") {
          nvs[cArray[i].substring(0, cArray[i].indexOf(":"))] = cArray[i].substring(cArray[i].indexOf(":") + 1, cArray[i].length);
        }
      }

      //add the new cookie name/value pair
      nvs[theName] = theValue;

      //serialize it again
      var s = "";
      for (var n in nvs) s += "|" + n + ":" + nvs[n];

      //write the cookie
      var nextYear = new Date();
      nextYear.setFullYear(nextYear.getFullYear()+1);
      var c = "Xopus=" + s + "|; expires=" + nextYear.toGMTString() + "; path=/;";

      xopus_globs.document.cookie = "Xopus=";
      xopus_globs.document.cookie = c;
    }
  } catch (e) {
  }
}

function castValue(theValue) {
  if (theValue == '') return theValue;
  if (!isNaN(1*theValue)) return 1*theValue;
  if (theValue == "true") return true;
  if (theValue == "false") return false;
  return theValue;
}

numScriptsLoading--;
