////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function Help(appID, curLanguage) {
  this.appID = appID;
  this.curLanguage = null;
  this.attachIDs = [];
  this.curID = null;
  this.nextID = null;
  this.defaultMsgs = null;
  this.msgs = {};
  this.toh = null;
  this.lastTime = -1;
  this.lastEl = null;
  this.lastCursorEl = null;
  this.lastCursorCursor = null;
  this.lastMouseX = null;
  this.lastMouseY = null;

  //create balloon
  var div = document.createElement('div');
  div.id = 'xopus_contexthelp_balloon';
  this.balloon = document.body.appendChild(div);
  this.balloon.innerHTML = ''
    + '<table border="0" cellspacing="0" cellpadding="0">'
    + '<tr><td class="xopus_help_small"><img src="' + xopus_globs.basePath + 'xopus/help/tl.gif" galleryimg="no" width="7" height="7" /></td><td class="xopus_help_t">&nbsp;</td><td class="xopus_help_small"><img src="' + xopus_globs.basePath + 'xopus/help/tr.gif" galleryimg="no" width="7" height="7" /></td></tr>'
    + '<tr><td class="xopus_help_l">&nbsp;</td><td id="xopus_contexthelp_contents" align="left" valign="top"></td><td class="xopus_help_r">&nbsp;</td></tr>'
    + '<tr><td class="xopus_help_small"><img src="' + xopus_globs.basePath + 'xopus/help/bl.gif" galleryimg="no" width="7" height="7" /></td><td class="xopus_help_b">&nbsp;</td><td class="xopus_help_small"><img src="' + xopus_globs.basePath + 'xopus/help/br.gif" galleryimg="no" width="7" height="7" /></td></tr>'
    + '</table>';
  this.balloonContents = document.getElementById('xopus_contexthelp_contents');

  //load help document by setting the language
  this.applyLanguage(curLanguage);

  //suscribe help to a language change
  xopus_globs.subscribe('language', null, function(name, value) { xopus_globs.help.applyLanguage(value); } );
}

Help.prototype = {
  toggleActive:function() {
    var msgs = this.msgs[this.curLanguage];
    if (!msgs) return;

    this.isActive = !this.isActive;
    this.nextID = null;
    this.curID = null;

    //reflect state in toolbar button and logomenu
    xopus_globs.toolbardefinition.logoMenu.items.contexthelp.checked = this.isActive;
    xopus_globs.toolbardefinition.toolbar.standard.items.contexthelp.down = this.isActive;
    document.getElementById('xopus_toolbar_item_contexthelp').className = 'xopus_toolbar_item' + (this.isActive?'_sel':'');

    // Attach the events to the toolbar and to all Xopus frames.
    if (this.isActive) 
    {
      this.attachIDs = [];
      this.attachIDs.push(xopus_globs.framework.attachEvent(document, 'onmousemove', xopus_globs.help, 'doMouseMove'));
      this.attachIDs.push(xopus_globs.framework.attachEvent(document, 'onmouseout', xopus_globs.help, 'doMouseOut'));
      
      for (var xopus in xopus_globs.xopi)
      {
        this.attachIDs.push(xopus_globs.framework.attachEvent(xopus_globs.xopi[xopus].htmldocument, 'onmousemove', xopus_globs.help, 'doMouseMove'));
        this.attachIDs.push(xopus_globs.framework.attachEvent(xopus_globs.xopi[xopus].htmldocument, 'onmouseout', xopus_globs.help, 'doMouseOut'));
      }
    } 
    else 
    {
      // Erase previous help cursor
      if (this.lastCursorEl) 
      {
        this.lastCursorEl.style.cursor = this.lastCursorCursor;
        this.lastCursorEl = null;
      }

      if (this.toh) {
        clearTimeout(this.toh);
        this.toh = null;
      }
      
      for (var i = 0; i < this.attachIDs.length; i++)
        xopus_globs.framework.detachEvent(this.attachIDs[i]);
      
      this.balloon.style.top = '-2000px';
    }

    //show help
    if (this.isActive && xopus_globs.contexthelphelp) xopus_globs.dialog.alert(xopus_globs.locale.getString('contexthelphelp'), xopus_globs.help, 'doOKHelp');
  },
  applyLanguage:function(newLanguage) {
    if (newLanguage != this.curLanguage) {
      this.curLanguage = newLanguage;

      if (!this.msgs[this.curLanguage]) {
        //initialize messages
        this.msgs[this.curLanguage] = {};

        if (!this.defaultMsgs) {
          //load default help document
          this.loadHelpFile(xopus_globs.basePath + 'xopus/help/helpMessages_default.xml', this.msgs[this.curLanguage]);
          this.defaultMsgs = this.msgs;
          this.msgs = {};
        }
        
        //copy default messages to the new msgs object
        for (var msgid in this.defaultMsgs) {
          this.msgs[msgid] = this.defaultMsgs[msgid];
        }

        //load language specific help document
        this.loadHelpFile(xopus_globs.basePath + 'xopus/help/helpMessages_' + this.curLanguage + '.xml', this.msgs[this.curLanguage]);

        //load CMS specific help document
        this.loadHelpFile(xopus_globs.basePath + 'xopusPlugins/helpMessages_' + this.curLanguage + xopus_globs.cmsPostfix + '.xml', this.msgs[this.curLanguage]);
      }
    }
  },
  loadHelpFile:function(url, msgs) {
    var xml = xopus_globs.xmllib.load(url, true);
    if (!xml) return;
    var nodes = xml.selectNodes("/messages/m[not(@browser) or (@browser='*') or (@browser='" + xopus_globs.browser.name + "')]");
    for (var i=0; i<nodes.length; i++) {
      var ids = nodes[i].getAttribute('id').split(',');
      var msg = nodes[i].xml.substring(nodes[i].xml.indexOf('>')+1, nodes[i].xml.lastIndexOf('<'));
      for (var j=0; j<ids.length; j++) {
        msgs[ids[j]] = msg;
      }
    }
  },
  doMouseOut:function(evt) {
    if (evt.clientX == -1) {
      if (this.toh) {
        clearTimeout(this.toh);
        this.toh = null;
      }
      this.nextID = null;
      this.lastEl = null;
      this.lastMouseX = -1;
      this.lastMouseY = -1;
      this.changeID();
    }
  },
  doMouseMove:function(evt) {
    var time = (new Date()).getTime();
    if (time - this.lastTime < (this.curID?0:70)) return;
    
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    var helpEl = null;
    var id = null;
    var msgs = this.msgs[this.curLanguage];

    this.lastTime = time;
    this.lastEl = el;
    this.lastMouseX = evt.clientX;
    this.lastMouseY = evt.clientY;

    // Find an ancestor with help attached
    while (el && !id) 
    {
      if (el.id && msgs[el.id]) id = el.id;
      else if (el.className && msgs[el.className]) id = el.className;
      else if (el.nodeType == 1 && el.getAttribute("xpath")) id = el.getAttribute("xpath");
      else el = el.parentNode;
    }
    
    // Store the element with help attached
    this.helpEl = el;
    
    //erase previous help cursor
    if ((el != this.lastCursorEl) && this.lastCursorEl) {
      this.lastCursorEl.style.cursor = this.lastCursorCursor;
      this.lastCursorEl = null;
    }

    if (id) {
      // Use element which has help attached.
      var overEl = this.helpEl;
      
      //show help and remember old cursor
      if (overEl && (overEl != this.lastCursorEl)) {
        this.lastCursorCursor = xopus_globs.browser.ie?overEl.currentStyle.cursor:document.defaultView.getComputedStyle(overEl, "").getPropertyValue("cursor");
        this.lastCursorEl = overEl;
        overEl.style.cursor = 'help';
      }

      if (id != this.curID) {
        if (id != this.nextID) {
          var nextID = (this.curID?null:id);
          if (!this.toh || (nextID != this.nextID)) {
            this.nextID = nextID;
            if (this.toh) clearTimeout(this.toh);
            this.toh = setTimeout('xopus_globs.help.changeID();', (this.curID?300:1200));
          }
        }
      } else {
        if (this.toh) {
          clearTimeout(this.toh);
          this.toh = null;
          this.nextID = null;
        }
      }
      if (this.curID) this.positionBalloon();
    } else {
      if (this.toh) {
        clearTimeout(this.toh);
        this.toh = null;
      }
      this.nextID = id;
      this.changeID();
    }

//status = id + ', ' + this.curID + ', ' + this.nextID;
  },
  positionBalloon:function() {
      //position the balloon
      var w = this.balloon.offsetWidth;
      var h = this.balloon.offsetHeight;
      var sw = document.body.offsetWidth;
      var sh = document.body.offsetHeight;

      var x = this.lastMouseX - 7;
      if (x + w > sw - 10) x = sw - 10 - w + 7;
      var y = this.lastMouseY - h - 7;
      if (y < 10) y = this.lastMouseY + 37;
      if (y + h > sh - 10) y = sh - 10 - h + 7;
      if (y < 10) y = 10;
      this.balloon.style.top = y + 'px';
      this.balloon.style.left = x + 'px';
  },
  changeID:function() {
    if (this.curID && this.nextID) {
      this.curID = null;
      this.balloon.style.top = '-2000px';
      this.toh = setTimeout('xopus_globs.help.changeID();', 400);
    } else {
      this.curID = this.nextID;
      this.toh = null;
      if (this.curID) {
        var msgs = this.msgs[this.curLanguage];
        msg = msgs[this.curID];
        
        // Check if there was a msg for this id, if not it must be an xpath
        if (!msg)
        {
          var id    = this.helpEl.id;
          var xopus = this.helpEl.xopusObject;
          
          var context = new Context(id, xopus);
          var node    = xopus.getNode(this.helpEl.getAttribute("xpath"));
          
          if (node.nodeType == 3)
            node = node.parentNode;
          
          msg = context.getPrettyLongDescription(node);
        }
        
        this.balloonContents.innerHTML = msg;
        this.positionBalloon();
      } else {
        this.balloon.style.top = '-2000px';
        setTimeout('xopus_globs.help.doMouseMove({srcElement:xopus_globs.help.lastEl, clientX:xopus_globs.help.lastMouseX, clientY:xopus_globs.help.lastMouseY});', 1);
      }
    }
  },
  doOKHelp:function(el) {
    if (xopus_globs.window.document.getElementById('xopus_contexthelp_never').checked) xopus_globs.store('contexthelphelp', false);
  }
}

numScriptsLoading--;
