////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function ObjectFactory(){}

ObjectFactory.prototype =
{
  /**
   * Create an XMLHTTPRequest object.
   */
  createXMLHttpRequest: function()
  {
    if (xopus_globs.browser.moz)
      return new XMLHttpRequest();
    else
      return new ActiveXObject("MSXML2.XmlHttp.4.0");
  },
  
  /**
   * Create an XSLTProcessor object for the given xsl template.
   */
  createXSLTProcessor: function (xslDoc)
  {
    if (xopus_globs.browser.moz)
    {
      var xslProc = new XSLTProcessor();
      xslProc.stylesheet = xslDoc;
      
      return xslProc;
    }
    else
    {
      var freeThreadedDOM = new ActiveXObject("MSXML2.FreeThreadedDOMDocument.4.0");
      freeThreadedDOM.async = false;

      //more info: http://msdn.microsoft.com/library/en-us/xmlsdk/htm/xml_mth_sz_8m49.asp?frame=true
      freeThreadedDOM.setProperty("NewParser", true);

      freeThreadedDOM.loadXML(xslDoc.xml);
      var xslTemplate = new ActiveXObject("MSXML2.XSLTemplate.4.0");
      xslTemplate.stylesheet = freeThreadedDOM;
      var xslProc = xslTemplate.createProcessor();

      return xslProc;
    }
  },
  
  /**
   * Create an empty XML DOM.
   */
  createXMLDOM: function(xml)
  {
    if (xopus_globs.browser.moz)
    {
      var xmlDOM = document.implementation.createDocument("text/xml", "", null);
    }
    else
    {
      var xmlDOM = new ActiveXObject("MSXML2.DOMDocument.4.0");
      xmlDOM.async = false;

      //more info: http://msdn.microsoft.com/library/en-us/xmlsdk/htm/xml_mth_sz_8m49.asp?frame=true
      xmlDOM.setProperty("NewParser", true);

      xmlDOM.validateOnParse = false;
    }

    if (xml) {
      xmlDOM.loadXML(xml);
    }

    return xmlDOM;
  },
  
  /**
   * Create a schema cache.
   */
  createXMLSchemaCache: function()
  {
    if (xopus_globs.useXopusSOM || xopus_globs.browser.moz)
      return new XMLSchemaCache();
    else
      return new ActiveXObject("MSXML2.XMLSchemaCache.4.0");
  }
};

numScriptsLoading--;
