<!-- This stylesheet converts our processing instructions to div elements marking the nodes -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">  
    
  <xsl:template match="*">
    <xsl:choose>
      <xsl:when test="following-sibling::processing-instruction('xopus_element')[substring-before(.,'=') = name(current())]">
        <div xopus_type="element" xopus_editor="true" style="display:inline;">
          <xsl:attribute name="xpath"><xsl:value-of select="substring-after(following-sibling::processing-instruction('xopus_element')[substring-before(.,'=') = name(current())], '=')"/></xsl:attribute>
          <xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-templates select="*|text()" mode="dontMark"/></xsl:copy>
        </div></xsl:when>
      <xsl:otherwise>
        <xsl:copy><xsl:apply-templates select="*|@*|text()"/></xsl:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="*" mode="dontMark">
    <xsl:if test="not(namespace-uri()='http://www.xopus.org/xmlns/id')">
      <xsl:copy><xsl:apply-templates select="*|@*|text()" mode="dontMark"/></xsl:copy>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="text()">
    <xsl:choose>
      <xsl:when test="name(preceding-sibling::processing-instruction()[1]) = 'xopus_separator' and name(following-sibling::processing-instruction()[1]) = 'xopus_text'">
        <div xopus_type="text" xopus_editor="true" style="display:inline;">
          <xsl:attribute name="xpath"><xsl:value-of select="following-sibling::processing-instruction('xopus_text')[1]"/></xsl:attribute>
          <xsl:copy-of select="."/>
        </div>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="text()" mode="dontMark">
    <xsl:copy-of select="."/>
  </xsl:template>
  
  <xsl:template match="@*">
    <xsl:choose>
      <xsl:when test="../processing-instruction('xopus_attribute')[substring-before(.,'=') = name(current())]">
        <xsl:copy-of select="."/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="@*" mode="dontMark">
    <xsl:if test="not(namespace-uri()='http://www.xopus.org/xmlns/id')">
      <xsl:copy-of select="."/>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
