////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

var SOMITEM_SCHEMA         = 4 * 1024;
var SOMITEM_ATTRIBUTE      = SOMITEM_SCHEMA + 1;
var SOMITEM_ATTRIBUTEGROUP = SOMITEM_SCHEMA + 2;
var SOMITEM_NOTATION       = SOMITEM_SCHEMA + 3;

var SOMITEM_ANYTYPE        = 8 * 1024;
var SOMITEM_DATATYPE       = SOMITEM_ANYTYPE  + 256;
var SOMITEM_SIMPLETYPE     = SOMITEM_DATATYPE + 256;
var SOMITEM_COMPLEXTYPE    = 9 * 1024;

var SOMITEM_PARTICLE       = 16 * 1024;
var SOMITEM_ANY            = SOMITEM_PARTICLE + 1;
var SOMITEM_ANYATTRIBUTE   = SOMITEM_PARTICLE + 2;
var SOMITEM_ELEMENT        = SOMITEM_PARTICLE + 3;
var SOMITEM_GROUP          = SOMITEM_PARTICLE + 256;
  
var SOMITEM_ALL            = SOMITEM_GROUP + 1;
var SOMITEM_CHOICE         = SOMITEM_GROUP + 2;
var SOMITEM_SEQUENCE       = SOMITEM_GROUP + 3;
var SOMITEM_EMPTYPARTICLE  = SOMITEM_GROUP + 4;

// Attribute uses
var SCHEMAUSE_OPTIONAL     = 0;
var SCHEMAUSE_PROHIBITED   = 1;
var SCHEMAUSE_REQUIRED     = 2;

var SCHEMACONTENTTYPE_EMPTY       = 0;
var SCHEMACONTENTTYPE_TEXTONLY    = 1;
var SCHEMACONTENTTYPE_ELEMENTONLY = 2;
var SCHEMACONTENTTYPE_MIXED       = 3;

var SOMITEM_DATATYPE_ANYTYPE             = SOMITEM_DATATYPE + 1;
var SOMITEM_DATATYPE_ANYURI              = SOMITEM_DATATYPE + 2; 
var SOMITEM_DATATYPE_BASE64BINARY        = SOMITEM_DATATYPE + 3; 
var SOMITEM_DATATYPE_BOOLEAN             = SOMITEM_DATATYPE + 4; 
var SOMITEM_DATATYPE_BYTE                = SOMITEM_DATATYPE + 5; 
var SOMITEM_DATATYPE_DATE                = SOMITEM_DATATYPE + 6; 
var SOMITEM_DATATYPE_DATETIME            = SOMITEM_DATATYPE + 7; 
var SOMITEM_DATATYPE_DAY                 = SOMITEM_DATATYPE + 8; 
var SOMITEM_DATATYPE_DECIMAL             = SOMITEM_DATATYPE + 9; 
var SOMITEM_DATATYPE_DOUBLE              = SOMITEM_DATATYPE + 10;
var SOMITEM_DATATYPE_DURATION            = SOMITEM_DATATYPE + 11;
var SOMITEM_DATATYPE_ENTITIES            = SOMITEM_DATATYPE + 12;
var SOMITEM_DATATYPE_ENTITY              = SOMITEM_DATATYPE + 13;
var SOMITEM_DATATYPE_FLOAT               = SOMITEM_DATATYPE + 14;
var SOMITEM_DATATYPE_HEXBINARY           = SOMITEM_DATATYPE + 15;
var SOMITEM_DATATYPE_ID                  = SOMITEM_DATATYPE + 16; 
var SOMITEM_DATATYPE_IDREF               = SOMITEM_DATATYPE + 17; 
var SOMITEM_DATATYPE_IDREFS              = SOMITEM_DATATYPE + 18; 
var SOMITEM_DATATYPE_INT                 = SOMITEM_DATATYPE + 19; 
var SOMITEM_DATATYPE_INTEGER             = SOMITEM_DATATYPE + 20; 
var SOMITEM_DATATYPE_LANGUAGE            = SOMITEM_DATATYPE + 21; 
var SOMITEM_DATATYPE_LONG                = SOMITEM_DATATYPE + 22; 
var SOMITEM_DATATYPE_MONTH               = SOMITEM_DATATYPE + 23; 
var SOMITEM_DATATYPE_MONTHDAY            = SOMITEM_DATATYPE + 24; 
var SOMITEM_DATATYPE_NAME                = SOMITEM_DATATYPE + 25; 
var SOMITEM_DATATYPE_NCNAME              = SOMITEM_DATATYPE + 26; 
var SOMITEM_DATATYPE_NEGATIVEINTEGER     = SOMITEM_DATATYPE + 27;
var SOMITEM_DATATYPE_NMTOKEN             = SOMITEM_DATATYPE + 28; 
var SOMITEM_DATATYPE_NMTOKENS            = SOMITEM_DATATYPE + 29;
var SOMITEM_DATATYPE_NONNEGATIVEINTEGER  = SOMITEM_DATATYPE + 30;
var SOMITEM_DATATYPE_NONPOSITIVEINTEGER  = SOMITEM_DATATYPE + 31;
var SOMITEM_DATATYPE_NORMALIZEDSTRING    = SOMITEM_DATATYPE + 32; 
var SOMITEM_DATATYPE_NOTATION            = SOMITEM_DATATYPE + 33; 
var SOMITEM_DATATYPE_POSITIVEINTEGER     = SOMITEM_DATATYPE + 34; 
var SOMITEM_DATATYPE_QNAME               = SOMITEM_DATATYPE + 35; 
var SOMITEM_DATATYPE_SHORT               = SOMITEM_DATATYPE + 36; 
var SOMITEM_DATATYPE_STRING              = SOMITEM_DATATYPE + 37; 
var SOMITEM_DATATYPE_TIME                = SOMITEM_DATATYPE + 38; 
var SOMITEM_DATATYPE_TOKEN               = SOMITEM_DATATYPE + 39; 
var SOMITEM_DATATYPE_UNSIGNEDBYTE        = SOMITEM_DATATYPE + 40; 
var SOMITEM_DATATYPE_UNSIGNEDINT         = SOMITEM_DATATYPE + 41; 
var SOMITEM_DATATYPE_UNSIGNEDLONG        = SOMITEM_DATATYPE + 42;
var SOMITEM_DATATYPE_UNSIGNEDSHORT       = SOMITEM_DATATYPE + 43;
var SOMITEM_DATATYPE_YEAR                = SOMITEM_DATATYPE + 44;
var SOMITEM_DATATYPE_YEARMONTH           = SOMITEM_DATATYPE + 45;

var SOMBUILTIN_TYPES = {};
SOMBUILTIN_TYPES["anyType"]              = SOMITEM_DATATYPE_ANYTYPE;

SOMBUILTIN_TYPES["string"]               = SOMITEM_DATATYPE_STRING;
SOMBUILTIN_TYPES["boolean"]              = SOMITEM_DATATYPE_BOOLEAN;
SOMBUILTIN_TYPES["float"]                = SOMITEM_DATATYPE_FLOAT;
SOMBUILTIN_TYPES["double"]               = SOMITEM_DATATYPE_DOUBLE;
SOMBUILTIN_TYPES["duration"]             = SOMITEM_DATATYPE_DURATION;
SOMBUILTIN_TYPES["dateTime"]             = SOMITEM_DATATYPE_DATETIME;
SOMBUILTIN_TYPES["time"]                 = SOMITEM_DATATYPE_TIME;
SOMBUILTIN_TYPES["date"]                 = SOMITEM_DATATYPE_DATE;
SOMBUILTIN_TYPES["gYearMonth"]           = SOMITEM_DATATYPE_YEARMONTH;
SOMBUILTIN_TYPES["gYear"]                = SOMITEM_DATATYPE_YEAR;
SOMBUILTIN_TYPES["gMonthDay"]            = SOMITEM_DATATYPE_MONTHDAY;
SOMBUILTIN_TYPES["gDay"]                 = SOMITEM_DATATYPE_DAY;
SOMBUILTIN_TYPES["gMonth"]               = SOMITEM_DATATYPE_MONTH;
SOMBUILTIN_TYPES["hexBinary"]            = SOMITEM_DATATYPE_HEXBINARY;
SOMBUILTIN_TYPES["base64Binary"]         = SOMITEM_DATATYPE_BASE64BINARY;
SOMBUILTIN_TYPES["anyURI"]               = SOMITEM_DATATYPE_ANYURI;
SOMBUILTIN_TYPES["QName"]                = SOMITEM_DATATYPE_QNAME;
SOMBUILTIN_TYPES["NOTATION"]             = SOMITEM_DATATYPE_NOTATION;

SOMBUILTIN_TYPES["byte"]                 = SOMITEM_DATATYPE_BYTE;
SOMBUILTIN_TYPES["short"]                = SOMITEM_DATATYPE_SHORT;
SOMBUILTIN_TYPES["int"]                  = SOMITEM_DATATYPE_INT;
SOMBUILTIN_TYPES["long"]                 = SOMITEM_DATATYPE_LONG;
SOMBUILTIN_TYPES["decimal"]              = SOMITEM_DATATYPE_DECIMAL;
SOMBUILTIN_TYPES["integer"]              = SOMITEM_DATATYPE_INTEGER;
SOMBUILTIN_TYPES["negativeInteger"]      = SOMITEM_DATATYPE_NEGATIVEINTEGER;
SOMBUILTIN_TYPES["nonNegativeInteger"]   = SOMITEM_DATATYPE_NONNEGATIVEINTEGER;
SOMBUILTIN_TYPES["nonPositiveInteger"]   = SOMITEM_DATATYPE_NONPOSITIVEINTEGER;
SOMBUILTIN_TYPES["positiveInteger"]      = SOMITEM_DATATYPE_POSITIVEINTEGER;
SOMBUILTIN_TYPES["unsignedByte"]         = SOMITEM_DATATYPE_UNSIGNEDBYTE;
SOMBUILTIN_TYPES["unsignedInt"]          = SOMITEM_DATATYPE_UNSIGNEDINT;
SOMBUILTIN_TYPES["unsignedLong"]         = SOMITEM_DATATYPE_UNSIGNEDLONG;
SOMBUILTIN_TYPES["unsignedShort"]        = SOMITEM_DATATYPE_UNSIGNEDSHORT;
SOMBUILTIN_TYPES["language"]             = SOMITEM_DATATYPE_LANGUAGE;

SOMBUILTIN_TYPES["ENTITIES"]             = SOMITEM_DATATYPE_ENTITIES;
SOMBUILTIN_TYPES["ENTITY"]               = SOMITEM_DATATYPE_ENTITY;
SOMBUILTIN_TYPES["ID"]                   = SOMITEM_DATATYPE_ID;
SOMBUILTIN_TYPES["IDREF"]                = SOMITEM_DATATYPE_IDREF;
SOMBUILTIN_TYPES["IDREFS"]               = SOMITEM_DATATYPE_IDREFS;
SOMBUILTIN_TYPES["Name"]                 = SOMITEM_DATATYPE_NAME;
SOMBUILTIN_TYPES["NCName"]               = SOMITEM_DATATYPE_NCNAME;
SOMBUILTIN_TYPES["NMTOKEN"]              = SOMITEM_DATATYPE_NMTOKEN;
SOMBUILTIN_TYPES["NMTOKENS"]             = SOMITEM_DATATYPE_NMTOKENS;
SOMBUILTIN_TYPES["normalizedString"]     = SOMITEM_DATATYPE_NORMALIZEDSTRING;
SOMBUILTIN_TYPES["token"]                = SOMITEM_DATATYPE_TOKEN;

/**
 * Add limited SOM support to XMLDocuments.
 */
/*
XMLDocument.prototype.__defineSetter__("schemas", function(xmlSchemaCache)
{
  this.xmlSchemaCache = xmlSchemaCache;
});

XMLDocument.prototype.__defineGetter__("namespaces", function()
{
  return this.xmlSchemaCache;
});
*/
/************************************************
 * Define a new object as placeholder for the MSXML2.XMLSchemaCache ActiveXObject.
 *********************************************** */
function XMLSchemaCache()
{
  this.namespaceMapping = [];
}

XMLSchemaCache.prototype.add = function (namespaceURI, xsdDoc)
{
  this.namespaceMapping["prefix" + namespaceURI] = new Schema(xsdDoc.documentElement, this);
};

XMLSchemaCache.prototype.getDeclaration = function (node)
{
  var schema = this.getSchema(node.namespaceURI);
  
  // If no schema was found, the attribute might be in its parent element namespace.
  if (!schema && node.nodeType == 2)
    schema = this.getSchema(node.selectSingleNode("parent::*").namespaceURI);
  
  return schema.getDeclaration(node);
};

XMLSchemaCache.prototype.getSchema = function (namespaceURI)
{
  return this.namespaceMapping["prefix" + (namespaceURI || "")];
};

/************************************************
 * Represents a SchemaItem and is the base interface for most SOM objects.
 *********************************************** */
function SchemaItem(schemaElt, ownerSchema)
{
  this.initSchemaItem(schemaElt, ownerSchema);
}

SchemaItem.prototype.initSchemaItem = function(schemaElt, ownerSchema)
{
  this.schemaElt    = schemaElt;
  this.name         = schemaElt.getAttribute("name");
  this.id           = schemaElt.getAttribute("id");
  this.schema       = ownerSchema;
  this.namespaceURI = ownerSchema.targetNamespace;
  //this.annotation   = schemaElt.selectSingleNode("*[local-name()='annotation' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  this.annotation   = xopus_globs.utils.getChildByName(schemaElt, {annotation: true}, "http://www.w3.org/2001/XMLSchema");
  this.itemType     = SOMITEM_SCHEMA;
};

/************************************************
 * Represents a built-in type.
 *
 * Cannot be 'subclassed', so no init function.
 *********************************************** */
function SchemaBuiltInType(name)
{
  this.name         = name;
  this.namespaceURI = "http://www.w3.org/2001/XMLSchema";
  this.itemType     = SOMBUILTIN_TYPES[name];
}

/************************************************
 * Represents an XML schema
 *********************************************** */
function Schema (schemaElt, schemaCache)
{
  this.initSchema(schemaElt, schemaCache);
}
 
/**
 * Inherit the SchemaItem functions.
 */
for (var i in SchemaItem.prototype)
  Schema.prototype[i] = SchemaItem.prototype[i];

Schema.prototype.initSchema = function (schemaElt, schemaCache)
{
  this.initSchemaItem(schemaElt, this);
  this.itemType = SOMITEM_SCHEMA;
  this.targetNamespace = schemaElt.getAttribute("targetNamespace") || "";
  this.prefix = schemaElt.prefix;
  this.cache = schemaCache;
  
  //var typeNodes = this.schemaElt.selectNodes(
  //      "*[(local-name()='simpleType' or local-name()='complexType') and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  //var elementNodes = this.schemaElt.selectNodes(
  //      "*[local-name()='element' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  //var attributeNodes = this.schemaElt.selectNodes(
  //      "*[local-name()='attribute' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  //var attributeGroupNodes = this.schemaElt.selectNodes(
  //      "*[local-name()='attributeGroup' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  //var modelGroupNodes = this.schemaElt.selectNodes(
  //      "*[local-name()='modelGroup' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  
  var typeNodes           = xopus_globs.utils.getChildrenByName(this.schemaElt, {simpleType: true, complexType: true}, "http://www.w3.org/2001/XMLSchema");
  var elementNodes        = xopus_globs.utils.getChildrenByName(this.schemaElt, {element: true}, "http://www.w3.org/2001/XMLSchema");
  var attributeNodes      = xopus_globs.utils.getChildrenByName(this.schemaElt, {attribute: true}, "http://www.w3.org/2001/XMLSchema");
  var attributeGroupNodes = xopus_globs.utils.getChildrenByName(this.schemaElt, {attributeGroup: true}, "http://www.w3.org/2001/XMLSchema");
  var modelGroupNodes     = xopus_globs.utils.getChildrenByName(this.schemaElt, {group: true}, "http://www.w3.org/2001/XMLSchema");
  
  this.types           = new SchemaItemCollection(typeNodes, this, null);
  this.elements        = new SchemaItemCollection(elementNodes, this, null);
  this.attributes      = new SchemaItemCollection(attributeNodes, this, null);
  this.attributeGroups = new SchemaItemCollection(attributeGroupNodes, this, null);
  this.modelGroups     = new SchemaItemCollection(modelGroupNodes, this, null);
  this.builtInTypes    = {};
  
  for (var name in SOMBUILTIN_TYPES)
    this.builtInTypes[name] = new SchemaBuiltInType(name);
};

Schema.prototype.getDeclaration = function (node)
{
  // The node is an attribute
  if (node.nodeType == 2)
    return this.getAttributeDeclaration(node);
  // Assume it's an element
  else
    return this.getElementDeclaration(node);
};

Schema.prototype.getElementDeclaration = function (node)
{
  var ancestors = node.selectNodes("ancestor-or-self::*");
  if (!ancestors[0])
    __xopus_alert("Schema.prototype.getElementDeclaration");
  
  status=(ancestors[0].namespaceURI);
  var schema = this.cache.getSchema(ancestors[0].namespaceURI);
  var decl = schema.elements.itemByQName(xopus_globs.utils.getLocalName(ancestors[0]), ancestors[0].namespaceURI);
  
  for (var i = 1; decl && i < ancestors.length; i++)
    decl = decl.getChildDeclaration(ancestors[i]);
  
  return decl;
};

Schema.prototype.getAttributeDeclaration = function (node)
{
  var parentDecl = this.getElementDeclaration(node);
  
  return parentDecl.getChildDeclaration(node);
  
};

Schema.prototype.isBuiltInType = function (type)
{
  return type.match(new RegExp(this.prefix + ":.*"));
};

Schema.prototype.getBuiltInType = function (type)
{
  // Strip prefix
  type = type.substr(this.prefix.length + 1);
  
  return this.builtInTypes[type];
};

Schema.prototype.getPrefix = function (name)
{
  return name.substr(0, name.indexOf(":"));
};

Schema.prototype.getName = function (name)
{
  return name.substr(name.indexOf(":") + 1);
};

Schema.prototype.getSchemaByPrefix = function (node, prefix)
{
  if (prefix == "")
    return this;
  
  var namespace = xopus_globs.utils.getNamespaceForPrefix(node, prefix);
  
  return this.cache.getSchema(namespace);
};

/************************************************
 * Represents a schema particle
 *********************************************** */
function SchemaParticle (schemaElt, ownerSchema)
{
  this.initSchemaParticle(schemaElt, ownerSchema);
};
 
/**
 * Inherit the SchemaItem functions.
 */
for (var i in SchemaItem.prototype)
  SchemaParticle.prototype[i] = SchemaItem.prototype[i];

SchemaParticle.prototype.initSchemaParticle = function (schemaElt, ownerSchema)
{
  this.initSchemaItem(schemaElt, ownerSchema);
  this.minOccurs = schemaElt.getAttribute("minOccurs");
  this.maxOccurs = schemaElt.getAttribute("maxOccurs");
  
  if (!this.minOccurs)
    this.minOccurs = "1";
  
  if (!this.maxOccurs)
    this.maxOccurs = "1";
  
  if (this.maxOccurs == "unbounded")
    this.maxOccurs = "-1";
  
  this.minOccurs = parseInt(this.minOccurs);
  this.maxOccurs = parseInt(this.maxOccurs);
  
  this.itemType = SOMITEM_PARTICLE;
};

/************************************************
 * Represents a schema attribute
 *********************************************** */
function SchemaAttribute (schemaElt, ownerSchema)
{
  this.initSchemaAttribute(schemaElt, ownerSchema);
};
 
/**
 * Inherit the SchemaItem functions.
 */
for (var i in SchemaItem.prototype)
  SchemaAttribute.prototype[i] = SchemaItem.prototype[i];

SchemaAttribute.prototype.initSchemaAttribute = function (schemaElt, ownerSchema, scope)
{
  this.initSchemaItem(schemaElt, ownerSchema);
  
  // This attribute is a ref
  var refAttr = this.schemaElt.getAttribute("ref");
  if (refAttr)
  {
    var prefix = this.schema.getPrefix(refAttr);
    var name   = this.schema.getName(refAttr);
    var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
    
    var refDecl = schema.attributes.itemByName(name); 
    
    // Use the local annotation if existent
    this.annotation   = xopus_globs.utils.getChildByName(schemaElt, {annotation: true}, "http://www.w3.org/2001/XMLSchema");
    if (!this.annotation)
      this.annotation = refDecl.annotation;
    
    this.name         = refDecl.name;
    this.type         = refDecl.type;
    this.use          = refDecl.use;
    this.defaultValue = refDecl.defaultValue;
    this.fixedValue   = refDecl.fixedValue;
    this.itemType     = refDecl.itemType;
    
    this.scope = scope;
    
    return;
  }
  
  switch (schemaElt.getAttribute("use"))
  {
    case "required":
      this.use = SCHEMAUSE_REQUIRED;
      break;
    case "prohibited":
      this.use = SCHEMAUSE_PROHIBITED;
      break;
    case "optional":
    default:
      this.use = SCHEMAUSE_OPTIONAL;
      break;
  }
  
  this.defaultValue = schemaElt.getAttribute("default");
  this.fixedValue = schemaElt.getAttribute("fixed");
  
  // There are three type options
  var typeAttr = schemaElt.getAttribute("type");
  
  // 1. type can be empty. Then the xsd:attribute element contains the simple type used. 
  if (!typeAttr)
  {
    //var typeNode = this.schemaElt.selectSingleNode("*[local-name()='simpleType' and " +
    //                                                   "namespace-uri()='http://www.w3.org/2001/XMLSchema']");
    var typeNode = xopus_globs.utils.getChildByName(this.schemaElt, {simpleType: true}, "http://www.w3.org/2001/XMLSchema");
    
    this.type = new SchemaType(typeNode, ownerSchema, scope);
  }
  // 2. type can be a built-in data type
  else if (this.schema.isBuiltInType(typeAttr))
    this.type = this.schema.getBuiltInType(typeAttr);
  // 3. type can reference a top level simple type
  else
  {
    var prefix = this.schema.getPrefix(typeAttr);
    var name   = this.schema.getName(typeAttr);
    var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
    this.type = schema.types.itemByName(name);
  }
  
  this.scope = scope;
  this.itemType = SOMITEM_ATTRIBUTE;
};

/************************************************
 * Represents a schema element
 *********************************************** */
function SchemaElement (schemaElt, ownerSchema, scope)
{
  this.initSchemaElement(schemaElt, ownerSchema, scope);
}
 
/**
 * Inherit the SchemaParticle functions.
 */
for (var i in SchemaParticle.prototype)
  SchemaElement.prototype[i] = SchemaParticle.prototype[i];

SchemaElement.prototype.initSchemaElement = function (schemaElt, ownerSchema, scope)
{
  this.initSchemaParticle(schemaElt, ownerSchema);
  this.itemType = SOMITEM_ELEMENT; 
  
  // This element is a ref
  var refAttr = this.schemaElt.getAttribute("ref");
  if (refAttr)
  {
    var prefix = this.schema.getPrefix(refAttr);
    var name   = this.schema.getName(refAttr);
    var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
    
    var refDecl = schema.elements.itemByName(name); 
    
    // TODO show error here if (!refDecl)
    
    // Use the local annotation if existent
    this.annotation   = xopus_globs.utils.getChildByName(schemaElt, {annotation: true}, "http://www.w3.org/2001/XMLSchema");
    if (!this.annotation)
      this.annotation = refDecl.annotation;
    
    this.name         = refDecl.name;
    this.namespaceURI = refDecl.namespaceURI;
    this.type         = refDecl.type;
    this.scope        = scope;
    
    return;
  }
  
  // There are three type options
  var typeAttr = schemaElt.getAttribute("type");
  
  // 1. type can be empty. Then the xsd:element element contains the complex or simple type used. 
  if (!typeAttr)
  {
    //var typeNode = this.schemaElt.selectSingleNode("*[local-name()='complexType' or local-name()='simpleType']" +
    //                                                    "[namespace-uri()='http://www.w3.org/2001/XMLSchema']");
    var typeNode = xopus_globs.utils.getChildByName(this.schemaElt, 
                                                    {complexType: true, simpleType: true}, 
                                                    "http://www.w3.org/2001/XMLSchema");
    
    // This is an empty element.
    if (!typeNode)
      this.type = new EmptyType(ownerSchema, scope);
    else if (xopus_globs.utils.getLocalName(typeNode) == "simpleType")
      this.type = new SchemaType(typeNode, ownerSchema, scope);
    else
      this.type = new SchemaComplexType(typeNode, ownerSchema, scope);
  }
  // 2. type can be a built-in data type
  else if (this.schema.isBuiltInType(typeAttr))
    this.type = this.schema.getBuiltInType(typeAttr);
  // 3. type can reference a top level complex or simple type
  else
  {
    var prefix = this.schema.getPrefix(typeAttr);
    var name   = this.schema.getName(typeAttr);
    var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
    this.type = schema.types.itemByName(name);
  }
  
  this.namespaceURI = this.schema.targetNamespace;
  this.scope = scope;
};

/**
 * Find the schema declaration for the given node.
 */
SchemaElement.prototype.getChildDeclaration = function (node, backupScope)
{
  return this.type.getChildDeclaration(node, backupScope);

};

/************************************************
 * Represents an empty schema model group
 ************************************************/
function EmptyModelGroup (ownerSchema, scope)
{
  this.initEmptyModelGroup(ownerSchema, scope);
}
 
EmptyModelGroup.prototype.initEmptyModelGroup = function (ownerSchema, scope)
{
  this.itemType = SOMITEM_EMPTYPARTICLE;
  this.particles = new SchemaItemCollection([], ownerSchema, scope);
}

/************************************************
 * Represents a schema model group
 ************************************************/
function SchemaModelGroup (schemaElt, ownerSchema, scope)
{
  this.initSchemaModelGroup(schemaElt, ownerSchema, scope);
}
 
/**
 * Inherit the SchemaParticle functions.
 */
for (var i in SchemaParticle.prototype)
  SchemaModelGroup.prototype[i] = SchemaParticle.prototype[i];

SchemaModelGroup.prototype.initSchemaModelGroup = function (schemaElt, ownerSchema, scope)
{
  this.initSchemaParticle(schemaElt, ownerSchema);
  
  // This group is a ref 
  // TODO: (only groups can be references)
  var refAttr = this.schemaElt.getAttribute("ref");
  if (refAttr)
  {
    var prefix = this.schema.getPrefix(refAttr);
    var name   = this.schema.getName(refAttr);
    var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
    
    var refDecl = schema.modelGroups.itemByName(name); 
    
    this.itemType  = refDecl.itemType;
    this.particles = refDecl.particles;
    this.scope     = scope;
    
    return;
  }
  
  var localName = xopus_globs.utils.getLocalName(this.schemaElt);
  switch (localName)
  {
    case "all":
      this.itemType = SOMITEM_ALL;
      break;
    case "choice":
      this.itemType = SOMITEM_CHOICE;
      break;
    case "group":
      this.itemType = SOMITEM_GROUP;
      break;
    case "sequence":
      this.itemType = SOMITEM_SEQUENCE;
      break;
    default:
      throw new Error("Unknown contentModel: " + localName);
      break;
  }
  
  var particleNodes = xopus_globs.utils.getChildrenByName(this.schemaElt, {any: true, choice: true, 
                                                                           element: true, group: true, 
                                                                           sequence: true}, "http://www.w3.org/2001/XMLSchema");
  this.particles = new SchemaItemCollection(particleNodes, ownerSchema, scope);
};

/**
 * Find the schema declaration for the given node.
 */
SchemaModelGroup.prototype.getChildDeclaration = function (node, backupScope)
{
  for (var i = 0; i < this.particles.length; i++)
  {
    var particle = this.particles.item(i);
    
    switch (particle.itemType)
    {
      case SOMITEM_ELEMENT:
        // TODO check for namespace here! there could be two elements in different namespaces. 
        if (particle.name == xopus_globs.utils.getLocalName(node))
        {
          // TODO this only works if the particle is refered to in one element.
          if (!particle.scope)
            particle.scope = backupScope;
          
          return particle;   
        }
        break;
      case SOMITEM_ALL:
      case SOMITEM_CHOICE:
      case SOMITEM_GROUP:
      case SOMITEM_SEQUENCE:
        var decl = particle.getChildDeclaration(node, backupScope);
        if (decl)
          return decl;
        break;
      default:
        __xopus_alert("Unknown particle.itemType: " + particle.itemType);
        break;
    }
  }

  return null;
};

/************************************************
 * Represents a schema type
 *********************************************** */
function SchemaType (schemaElt, ownerSchema, scope)
{
  this.initSchemaType(schemaElt, ownerSchema, scope);
}
 
/**
 * Inherit the SchemaItem functions.
 */
for (var i in SchemaItem.prototype)
  SchemaType.prototype[i] = SchemaItem.prototype[i];

SchemaType.prototype.initSchemaType = function (schemaElt, ownerSchema, scope)
{
  this.initSchemaItem(schemaElt, ownerSchema);
  this.itemType = SOMITEM_SIMPLETYPE;
  this.scope = scope;
};

SchemaType.prototype.getChildDeclaration = function (node)
{
  __xopus_alert("simpleTypes can't have children.");
  return null;
};

/************************************************
 * Represents an empty schema type
 *********************************************** */
function EmptyType (ownerSchema, scope)
{
  this.initEmptyType (ownerSchema, scope);
}
 
/**
 * Inherit the SchemaItem functions.
 */
for (var i in EmptyType.prototype)
  EmptyType.prototype[i] = SchemaType.prototype[i];

EmptyType.prototype.initEmptyType = function (ownerSchema, scope)
{
  this.itemType = SOMITEM_SIMPLETYPE;
  this.schema   = ownerSchema;
  this.namespaceURI = ownerSchema.targetNamespace;
  this.scope = scope;
};

/************************************************
 * Represents a schema complex type
 *********************************************** */
function SchemaComplexType (schemaElt, ownerSchema, scope)
{
  this.initSchemaComplexType(schemaElt, ownerSchema, scope);
}
 
/**
 * Inherit the SchemaType functions.
 *
 * TODO:
 *
 * - Add better support for simpleContent and complexContent
 * - Add support for attributeGroup
 */
for (var i in SchemaType.prototype)
  SchemaComplexType.prototype[i] = SchemaType.prototype[i];

SchemaComplexType.prototype.initSchemaComplexType = function (schemaElt, ownerSchema, scope)
{
  this.initSchemaType(schemaElt, ownerSchema, scope);
  
  /*var contentModelNode = this.schemaElt.selectSingleNode("*[local-name()='group' or local-name()='all' or " +
                                                             "local-name()='choice' or local-name()='sequence' or " +
                                                             "local-name()='simpleContent' or local-name()='complexContent']" +
                                                            "[namespace-uri()='http://www.w3.org/2001/XMLSchema']");
  */
  var contentModelNode = xopus_globs.utils.getChildByName(this.schemaElt, {group: true, all: true, choice: true, sequence:true, simpleContent: true, complexContent: true}, "http://www.w3.org/2001/XMLSchema");
  
  if (!contentModelNode)
  {
    this.itemType = SOMITEM_COMPLEXTYPE;
    this.contentType = SCHEMACONTENTTYPE_EMPTY;
    this.contentModel = new EmptyModelGroup(ownerSchema, this);
    this.attributes = new SchemaItemCollection([], ownerSchema, this); 
  }
  else
  {
    switch (xopus_globs.utils.getLocalName(contentModelNode))
    {
      case "group":
      case "all":
      case "choice":
      case "sequence":
        this.itemType = SOMITEM_COMPLEXTYPE;

        //var attributeNodes = this.schemaElt.selectNodes("*[local-name()='attribute' and namespace-uri()='http://www.w3.org/2001/XMLSchema']");
        var attributeNodes = xopus_globs.utils.getChildrenByName(this.schemaElt, {attribute: true}, "http://www.w3.org/2001/XMLSchema");
        this.attributes   = new SchemaItemCollection(attributeNodes, ownerSchema, this); 
        this.contentModel = new SchemaModelGroup(contentModelNode, ownerSchema, this);

        if (schemaElt.getAttribute("mixed") == "true")
          this.contentType = SCHEMACONTENTTYPE_MIXED;
        else
          this.contentType = SCHEMACONTENTTYPE_ELEMENTONLY;
        break;
      case "simpleContent":
      case "complexContent":
        //var inheritType = contentModelNode.selectSingleNode("*[local-name()='extension' or local-name()='restriction']" +
        //                                                           "[namespace-uri()='http://www.w3.org/2001/XMLSchema']");
        var inheritType = xopus_globs.utils.getChildByName(contentModelNode, {extension: true, restriction: true}, "http://www.w3.org/2001/XMLSchema");
        
        // TODO implement inheritance
        var baseType = inheritType.getAttribute("base");
        var base;
        if (this.schema.isBuiltInType(baseType))
          base = this.schema.getBuiltInType(baseType);
        else
        {
          var prefix = this.schema.getPrefix(baseType);
          var name   = this.schema.getName(baseType);
          var schema = this.schema.getSchemaByPrefix(this.schemaElt, prefix);
          base = schema.types.itemByName(name);  
          
          if (!base)
            __xopus_alert("Couldn't resolve " + baseType + " in InheritModelGroup.prototype.initInheritModelGroup\n");
        }
        
        this.itemType     = base.itemType;
        this.annotation   = base.annotation;
        this.attributes   = base.attributes;
        this.contentModel = base.contentModel;
        this.contentType  = base.contentType;
        break;
    }
  }
};

SchemaComplexType.prototype.getChildDeclaration = function (node, backupScope)
{
  var decl;

  if (!node)
    __xopus_alert("SchemaComplexType.prototype.getChildDeclaration");
  
  // TODO geen this.attributes soms. Komt door xsd:extension en het niet toevoegen van attributen.
  
  // Attribute?
  if (node.nodeType == 2)
    decl = this.attributes.itemByQName(xopus_globs.utils.getLocalName(node), node.namespaceURI);
  else
    decl = this.contentModel.getChildDeclaration(node, this);
  
  //if (decl == null)
  //  __xopus_alert("Could not find declaration for node:\n\n" + node.xml);
  
  return decl;
};

/************************************************
 * Represents a collection of schema items.
 *********************************************** */
function SchemaItemCollection(collection, ownerSchema, scope)
{
  this.domCollection = collection;
  this.ownerSchema   = ownerSchema;
  this.scope         = scope;
  
  this.indexCollection = null;
  this.nameCollection  = null;
  this.qNameCollection = null;
  this.length = this.domCollection.length;
}

/**
 * Lazy init function.
 */
SchemaItemCollection.prototype.init = function()
{
  this.indexCollection = {};
  this.nameCollection = [];
  this.qNameCollection = [];
  
  for (var i = 0; i < this.domCollection.length; i++)
  {
    var n = this.domCollection[i];
    if (!n)
      __xopus_alert("SchemaItemCollection.prototype.init");
    var localName = xopus_globs.utils.getLocalName(n);
    
    var item;
    switch(localName)
    {
      case "simpleType":
        item = new SchemaType(n, this.ownerSchema, this.scope);
        break;
      case "complexType":
        item = new SchemaComplexType(n, this.ownerSchema, this.scope);
        break;
      case "element":
        item = new SchemaElement(n, this.ownerSchema, this.scope);
        break;
      case "attribute":
        item = new SchemaAttribute(n, this.ownerSchema, this.scope);
        break;
      case "attributeGroup":
        item = new SchemaAttributeGroup(n, this.ownerSchema, this.scope);
        break;
      case "all":
      case "any":
      case "choice":
      case "group":
      case "sequence":
      case "modelGroup":
        item = new SchemaModelGroup(n, this.ownerSchema, this.scope);
        break;
      default:
        throw new Error("Unknown type: " + localName);
        break;
    }
    
    this.indexCollection[i] = item;
    this.nameCollection[item.name] = item;
    this.qNameCollection["{}" + item.name] = item;
  }
};

SchemaItemCollection.prototype.item = function(idx)
{
  if (this.indexCollection == null)
    this.init();
  
  return this.indexCollection[idx];
};

SchemaItemCollection.prototype.itemByName = function(name)
{
  if (this.nameCollection == null)
    this.init();
  
  return this.nameCollection[name];
};

SchemaItemCollection.prototype.itemByQName = function(localName, namespaceURI)
{
  if (this.qNameCollection == null)
    this.init();
  
  //if (!this.qNameCollection["{}" + localName])
  //  __xopus_alert("Couldn't find '" + localName+ "' in namespace: '" + this.ownerSchema.targetNamespace + "'");
  
  return this.qNameCollection["{}" + localName];
};


numScriptsLoading--;