////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

//TODO
// in xopus hangen
// titles van buttons uit locale halen
// applyLanguage doen bij language change
// animaties van acties
// borders oplichten bij mouseover van button
// prettynames in nieuwe cellen

//later:
//border, cellspacing, cellpadding, width, height, style
//rowspan, colspan


function TableEditor(theWindow)
{
  this.document = theWindow.document;
  this.table = null;
  this.curContext = null;
  this.toh = null;

  //create a stylesheet
  var css = theWindow.document.createStyleSheet();
  css.addRule('.xopus_tableeditor_table_noborder', 'background:red; margin:1px 0px 0px 1px;');
  css.addRule('.xopus_tableeditor_table_noborder td', 'padding:0px 1px 1px 0px;');

  css.addRule('.xopus_tableeditor_table_attention', 'border:dashed lightgrey; border-width:1px 0px 0px 1px;');
  css.addRule('.xopus_tableeditor_table_attention td', 'border:dashed lightgrey; border-width:0px 1px 1px 0px;');

  css.addRule('#xopus_tableeditor_menuicon', 'position:absolute; top:-100px; left:-100px; cursor:pointer; cursor:hand; z-index:1000000;');

  //create menu icon
  var img = this.document.createElement('img');
  img.id = 'xopus_tableeditor_menuicon';
  img.src = xopus_globs.basePath + 'xopus/media/icons/inserttable.gif';
  img.unselectable = "on";
  img.title = xopus_globs.locale.getString('tableeditor_icon');
  this.menuicon = this.document.body.appendChild(img);

  //create a contextmenu definition
  var tableeditor = this;
  this.contextmenutd = {
    id:'tableeditorcontextmenutd',
    showAsMenu:false,
    items:{
      insertrowbefore:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/insertrowbefore.gif', onclick:function(id){tableeditor.doAction(id);} },
      insertrowafter:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/insertrowafter.gif', onclick:function(id){tableeditor.doAction(id);} },
      moverowbackward:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/moverowbackward.gif', onclick:function(id){tableeditor.doAction(id);} },
      moverowforward:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/moverowforward.gif', onclick:function(id){tableeditor.doAction(id);} },
      deleterow:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/deleterow.gif', onclick:function(id){tableeditor.doAction(id);} },
      separator:{},
      insertcolbefore:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/insertcolbefore.gif', onclick:function(id){tableeditor.doAction(id);} },
      insertcolafter:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/insertcolafter.gif', onclick:function(id){tableeditor.doAction(id);} },
      movecolbackward:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/movecolbackward.gif', onclick:function(id){tableeditor.doAction(id);} },
      movecolforward:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/movecolforward.gif', onclick:function(id){tableeditor.doAction(id);} },
      deletecol:{ disabled:false, icon:xopus_globs.basePath + 'xopus/tableeditor/deletecol.gif', onclick:function(id){tableeditor.doAction(id);} }
    }};
  

  //suscribe to a language change
  xopus_globs.subscribe('language', this, 'applyLanguage');
}


TableEditor.prototype =
{
  applyLanguage:function() {
    this.menuicon.title = xopus_globs.locale.getString('tableeditor_icon');
  },
  doMouseMove: function(evt, theWindow) {
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el && (el.nodeType == 3)) el = el.parentNode;

    //detect whether over some table editor icon
    overTEButton =  (el.id.indexOf('xopus_tableeditor') != -1);
    if (overTEButton) return;

    //detect whether there is a current editor
    var curContext = Context.getCurrent();
    if (!curContext) {
      if (this.table) {
        //hide table editor
        this.hideTableEditor(this.table);
        this.table = null;

        return;
      }
      return;
    }
    var curEditor = curContext.getEditor();

    //detect whether inside editable part
    if (!el || !el.isContentEditable) {
      //hide table editor
      this.hideTableEditor(this.table);
      this.table = null;

      return;
    }

    //detect whether inside table
    var table = el;
    while (table && (table.nodeName.toLowerCase() != 'table') && table.isContentEditable) table = table.parentNode;
    if (!table || (table.nodeName.toLowerCase() != 'table') || !table.isContentEditable) {
      //hide table editor
      this.hideTableEditor(this.table);
      this.table = null;

      return;
    }

    //detect whether inside current editor
    var el = table;
    while (el && (el != curEditor)) el = el.parentNode;
    if (!el) {
      //hide table editor
      this.hideTableEditor(this.table);
      this.table = null;

      return;
    }

    //detect whether inside the current table, if not detach from current table
    if (this.table && (table != this.table)) {
      this.hideTableEditor(this.table, true);
      this.table = null;
    }

    //cancel hide table editor if present
    if (this.toh) {
      clearTimeout(this.toh);
      this.toh = null;
    }

    //attach to new table
    if (!this.table) {
      this.table = table;

      //show menu icon and table border
      this.showTableEditor();
    }
  },
  showTableEditor:function() {
    if (this.toh) {
      clearTimeout(this.toh);
      this.toh = null;
    }

    if (this.lastTable && (this.table != this.lastTable)) this.hideTableEditor(this.lastTable, true);

    //show menu icon and table border
    var bcr = this.table.getBoundingClientRect();
    this.menuicon.style.top = (this.document.documentElement.scrollTop + this.document.body.scrollTop + bcr.top - 15) + 'px';
    this.menuicon.style.left = (this.document.documentElement.scrollLeft + this.document.body.scrollLeft + bcr.left - 10) + 'px';
//    this.table.className = 'xopus_tableeditor_table_attention';
    this.lastTable = this.table;
  },
  hideTableEditor:function(tableEl, now) {
    if (!now) {
      if (!this.toh) {
        var tableeditor = this;
        this.toh = setTimeout(function() { tableeditor.hideTableEditor(tableEl, true); }, 2000);
      }
    } else {
      if (this.toh) {
        clearTimeout(this.toh);
        this.toh = null;
      }

      //hide menu icon and table border
      this.menuicon.style.top = '-100px';
      this.menuicon.style.left = '-100px';
//      if (tableEl) {
//        if (tableEl.oldClassName) tableEl.className = tableEl.oldClassName;
//        else {
//          tableEl.removeAttribute('class');
//          tableEl.removeAttribute('className');
//        }
//      }
    }
  },
  doContextChange:function(context) {
    if (context == this.curContext) return;

    if (this.curContext) this.doContextLose(this.curContext);

    this.curContext = context;
    if (!context) return;

    var el = context.getEditor();
    if (!el) return;

//    var tables = el.getElementsByTagName('table');
//    for (var i=0; i<tables.length; i++) {
//      tables[i].oldClassName = (tables[i].className && (tables[i].className != 'xopus_tableeditor_table_attention'))?tables[i]:'';
//    }
  },
  doContextLose:function(context) {
    if (!context) context = this.curContext;
    if (!context) return;

    var el = context.getEditor();
    if (!el) return;

    //find all tables and make sure they loose their borders
    var tables = el.getElementsByTagName('table');
//    for (var i=0; i<tables.length; i++) {
//      if (tables[i].className == 'xopus_tableeditor_table_attention') this.hideTableEditor(tables[i], true);
//    }
  },
  doContextMenu:function(evt, theWindow) {
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el && (el.nodeType == 3)) el = el.parentNode;

    //find whether inside a td
    var td = el;
    while (td && (td.nodeName.toLowerCase() != 'td') && td.isContentEditable) td = td.parentNode;
    if (!td || (td.nodeName.toLowerCase() != 'td') || !td.isContentEditable) {
      return true;
    }
    
    //find whether inside the current table
    var table = el;
    while (table && (table.nodeName.toLowerCase() != 'table') && table.isContentEditable) table = table.parentNode;
    if (!table || (table.nodeName.toLowerCase() != 'table') || !table.isContentEditable || (table != this.table)) {
      return true;
    }
    
    //define context menu
    var tr = td.parentNode;
    var isFirstRow = !tr.previousSibling;
    var isLastRow = !tr.nextSibling;
    var isFirstCol = !td.previousSibling;
    var isLastCol = !td.nextSibling;
    this.contextmenutd.items.moverowforward.disabled = isLastRow;
    this.contextmenutd.items.moverowbackward.disabled = isFirstRow;
    this.contextmenutd.items.movecolforward.disabled = isLastCol;
    this.contextmenutd.items.movecolbackward.disabled = isFirstCol;
    this.contextmenutd.items.deleterow.disabled = (isFirstRow && isLastRow);
    this.contextmenutd.items.deletecol.disabled = (isFirstCol && isLastCol);

    //store some stuff
    this.curTD = td;
    this.curTR = tr;

    //call contextmenu
    xopus_globs.contextmenu.draw(theWindow, evt, this.contextmenutd, false, false);

    return false;    
  },
  doAction: function(action) {
    switch(action) {
      case "insertrowbefore":
        var newtr = this.curTR.parentNode.insertBefore(this.curTR.cloneNode(true), this.curTR);
        for (var i=0; i<newtr.childNodes.length; i++) {
          newtr.childNodes[i].innerHTML = "[" + xopus_globs.locale.getString("pretty:td") + "]";
        }
        break;
      case "insertrowafter":
        if (this.curTR.nextSibling) var newtr = this.curTR.parentNode.insertBefore(this.curTR.cloneNode(true), this.curTR.nextSibling);
        else var newtr = this.curTR.parentNode.appendChild(this.curTR.cloneNode(true));
        for (var i=0; i<newtr.childNodes.length; i++) {
          newtr.childNodes[i].innerHTML = "[" + xopus_globs.locale.getString("pretty:td") + "]";
        }
        break;
      case "deleterow":
        this.curTR.parentNode.removeChild(this.curTR);
        break;
      case "moverowbackward":
        this.curTR.parentNode.insertBefore(this.curTR, this.curTR.previousSibling);
        break;
      case "moverowforward":
        this.curTR.parentNode.insertBefore(this.curTR.nextSibling, this.curTR);
        break;
      case "insertcolbefore":
      case "insertcolafter":
      case "movecolforward":
      case "movecolbackward":
      case "deletecol":
        //get all cells affected
        var colNum = 0;
        var td = this.curTD.previousSibling;
        while (td) {
          colNum++;
          td = td.previousSibling;
        }

        var tds = [this.curTD];
        var tr = this.curTR.previousSibling;
        while (tr) {
          tds[tds.length] = tr.childNodes[colNum];
          tr = tr.previousSibling;
        }
        var tr = this.curTR.nextSibling;
        while (tr) {
          tds[tds.length] = tr.childNodes[colNum];
          tr = tr.nextSibling;
        }

        for (var i=0; i<tds.length; i++) {
          switch(action) {
            case "insertcolbefore":
              newtd = tds[i].parentNode.insertBefore(tds[i].cloneNode(true), tds[i]);
              newtd.innerHTML = "[" + xopus_globs.locale.getString("pretty:td") + "]";
              break;
            case "insertcolafter":
              if (tds[i].nextSibling) var newtd = tds[i].parentNode.insertBefore(tds[i].cloneNode(true), tds[i].nextSibling);
              else var newtd = tds[i].parentNode.appendChild(tds[i].cloneNode(true));
              newtd.innerHTML = "[" + xopus_globs.locale.getString("pretty:td") + "]";
              break;
            case "deletecol":
              tds[i].parentNode.removeChild(tds[i]);
              break;
            case "movecolforward":
              tds[i].parentNode.insertBefore(tds[i].nextSibling, tds[i]);
              break;
            case "movecolbackward":
              tds[i].parentNode.insertBefore(tds[i], tds[i].previousSibling);
              break;
          }
        }
        break;
    }

    xopus_globs.ui.store();
    xopus_globs.ui.notifyChanges(this.curContext.xopus);
  },
  doClick:function(evt, theWindow) {
    //find element
    var el = xopus_globs.browser.ie?evt.srcElement:evt.target;
    if (el && (el.nodeType == 3)) el = el.parentNode;

    if (el.id == 'xopus_tableeditor_menuicon') {
      var img = el;

      var tableeditor = this;
      var menu = {
        id:'tableeditor',
        items:{
          editborder:{ disabled:true, onclick:function(id){tableeditor.editBorder(id);} },
          editcellspacing:{ disabled:true, onclick:function(id){tableeditor.editCellspacing(id);} },
          editcellpadding:{ disabled:true, onclick:function(id){tableeditor.editCellpadding(id);} },
          separator:{},
          tableeditorhelp:{ onclick:function(id){tableeditor.help(id);} }
        },
        showAsMenu:true};
      xopus_globs.contextmenu.draw(theWindow, evt, menu, false, false);

      return false;
    }
    
    return true;
  },
  editBorder:function() {
__xopus_alert('editBorder');
  },
  editCellspacing:function() {
__xopus_alert('editCellspacing');
  },
  editCellpadding:function() {
__xopus_alert('editCellpadding');
  },
  help:function() {
    xopus_globs.dialog.alert(xopus_globs.locale.getString('tableeditorhelpmsg'), null, function(){});
  }
};

numScriptsLoading--;
