////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function TreeView() {
}

TreeView.prototype = {
  // Detect and switch the display of CDATA and comments from an inline view
  //  to a block view if the comment or CDATA is multi-line.
  f:function(e)
  {
    // if this element is an inline comment, and contains more than a single
    //  line, turn it into a block comment.
    if (e.className == "xopus_treeview_ci") {
      if (e.firstChild.innerText.indexOf("\n") > 0)
        this.fix(e, "xopus_treeview_cb");
    }

    // if this element is an inline cdata, and contains more than a single
    //  line, turn it into a block cdata.
    if (e.className == "xopus_treeview_di") {
      if (e.firstChild.innerText.indexOf("\n") > 0)
        this.fix(e, "xopus_treeview_db");
    }

    // remove the id since we only used it for cleanup
    e.id = "";
  },

  // Fix up the element as a "block" display and enable expand/collapse on it
  fix:function(e, cl)
  {
    // change the class name and display value
    e.className = cl;
    e.style.display = "block";

    // mark the comment or cdata display as a expandable container
    j = e.parentNode.firstChild;
    j.className = "xopus_treeview_c";

    // find the +/- symbol and make it visible - the dummy link enables tabbing
    k = j.firstChild;
    k.style.visibility = "visible";
    k.href = "#";
  },

  // Change the +/- symbol and hide the children.  This function works on "element"
  //  displays
  ch:function(e)
  {
    // find the +/- symbol
    mark = e.firstChild.firstChild;

    // if it is already collapsed, expand it by showing the children
    if (mark.innerHTML == "+")
    {
      mark.innerHTML = "-";
      for (var i = 1; i < e.childNodes.length; i++)
        e.childNodes[i].style.display = "";
    }

    // if it is expanded, collapse it by hiding the children
    else if (mark.innerHTML == "-")
    {
      mark.innerHTML = "+";
      for (var i = 1; i < e.childNodes.length; i++)
        e.childNodes[i].style.display="none";
    }
  },

  // Handle a mouse click
  doClick:function(evt)
  {
    try {
      var e = evt.srcElement;

      if (evt.target) e=evt.target.parentNode;

      // make sure we are handling clicks upon expandable container elements
      if (e.className != "xopus_treeview_c")
      {
        e = e.parentNode;
        if (!e || e.className != "xopus_treeview_c")
        {
          return;
        }
      }
      e = e.parentNode;

      // call the correct funtion to change the collapse/expand state and display
      if (e.className == "xopus_treeview_e")
        this.ch(e);
      if (e.className == "xopus_treeview_k")
        this.ch2(e);
    } catch(e) {}
  },

  // Erase bogus link info from the status window
  doFocus:function()
  {
    window.status=" ";
  }
}

numScriptsLoading--;
