////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

alert("xopus.js: Loading Xopus. Click on OK and please be patient ... (btw, this message will appear twice. We know it's confusing, but please don't panic!)");

function __xopus_getBasePath()
{
  // Get the base path: the path to the dir where the xopus dir resides
  var searchString = 'xopus/xopus.js';
  var scripts = document.getElementsByTagName('script');
  
  var path = '';
  for (var i = 0; i < scripts.length; i++)
  {
    var currSrc = scripts[i].src;
    var pos = currSrc.lastIndexOf(searchString);
    if (pos == (currSrc.length - searchString.length))
    {
      path = currSrc.substring(0, pos);
      break;
    }
  }
  return path;
}

//see if we are allowed to start Xopus or not
if (document.location.href.toLowerCase().indexOf('xopus=false') == -1) {
  var __xopus_basePath = __xopus_getBasePath();
  
  // See if we are already inside an xopus frame
  var __xopus_frame = window;
  while (__xopus_frame && (__xopus_frame.name != 'xopus')) {
    if (__xopus_frame == top) {
      __xopus_frame = null;
      break;
    } else {
      __xopus_frame = __xopus_frame.parent;
    }
  }

  // Not inside xopus, redirect
  if (!__xopus_frame || (__xopus_frame.name != 'xopus') || !__xopus_frame.xopus_globs) 
  {
    var searchData = '?rnd=' + Math.random();
    if (typeof(CMS) != 'undefined') searchData += '&CMS=' + escape(CMS);

    document.location.href = __xopus_basePath + 'xopus/xopus.html' + searchData + '#content=' + escape(document.location.href);
  } 
  // Inside xopus, attach some stuff
  else if (__xopus_frame.xopus_globs && __xopus_frame.xopus_globs.framework)
  {
    var xopus_globs = __xopus_frame.xopus_globs;

    // Load the xopus CSS
    document.write('<link rel="stylesheet" type="text/css" href="' + __xopus_basePath + 'xopus/xopus_' + xopus_globs.browser.name + '.css" />');
    document.write('<link rel="stylesheet" type="text/css" href="' + __xopus_basePath + 'xopus/treeview/tree.css" />');

    // Load the moz2ie library
    if (xopus_globs.browser.moz)
      document.write('<script language="JavaScript" src="' + __xopus_basePath + 'xopus/mozilla/moz2ie.js"><\/script>');

    xopus_globs.framework.attachEvent(window, "onload", window, "__xopus_doLoad");
    xopus_globs.framework.attachEvent(window, "onbeforeunload", window, "__xopus_doBeforeUnload");
    xopus_globs.framework.attachEvent(window, "onunload", window, "__xopus_doUnload");
  }
}

function __xopus_doLoad() {
  xopus_globs.eventCenter.doWindowLoad(window);

  __xopus_frame.scanDocument(window);

  //see if the Xopus frame is our parent frame
  if (__xopus_frame == window.parent) {
    //set our title in the parent Xopus frame
    __xopus_frame.document.title = 'Xopus: ' + (document.title?document.title:document.location.pathname);

    //save our url in the hash portion of the Xopus frame's location
    __xopus_frame.document.location.href = __xopus_frame.document.location.href.substring(0, __xopus_frame.document.location.href.indexOf('#')) + '#content=' + escape(window.document.location.href);
    __xopus_frame.prevLocationURL = __xopus_frame.document.location.href;
  }
}

function __xopus_doBeforeUnload(evt) {
  if (xopus_globs.isExiting || xopus_globs.isStandby) return;

  var unsavedChanges = false;

  //loop canvasses for xopus objects and destroy them
  for (var i=0; i<window.canvasses.length; i++) {
    var xopus = window.canvasses[i].xopusObj;
    unsavedChanges = unsavedChanges || xopus.hasChanged;
  }

  if (unsavedChanges) {
    evt.returnValue = xopus_globs.locale.getString('savechangesbeforeunload?');
  }
}

function __xopus_doUnload(evt)
{
  try 
  {
    var curContext = __xopus_frame.Context.getCurrent();
    var curXopus = (curContext?curContext.xopus:null);
    var prevContext = __xopus_frame.Context.getPrevious();
    var prevXopus = (prevContext?prevContext.xopus:null);

    //loop canvasses for xopus objects and destroy them
    for (var i=0; i<window.canvasses.length; i++) {
      var xopus = window.canvasses[i].xopusObj;

      //make sure no context (current nor previous) belongs to this xopus object
      if (curXopus && (xopus == curXopus)) __xopus_frame.Context.currentID = null;
      if (prevXopus && (xopus == prevXopus)) __xopus_frame.Context.previousContext = null;

      //remove the xopus object from the xopi collection
      delete xopus_globs.xopi[xopus.id];

      //destroy this xopus object
      xopus_globs.destroyJSObject(xopus);
    }

    // Remove all references to canvasses on this window
    window.canvasses = null;

    // Scan all frames inside the xopus frame to find remaining Xopus instances.
    if (__xopus_frame.scanFramesForEditors(__xopus_frame)) {
      // There is still an Xopus active
    } else {
      // Hide the toolbar if already visible
      if (xopus_globs.xopusStarted) {
        xopus_globs.set("xopusStarted", false);
      }
    }
  } catch(e) {}
}

function __xopus_alert(str) {
  if (xopus_globs.debug) alert(str);
}
