////////////////////////////////////////////////////////////////////////////////////
//
// This Code Is Licensed Under The Xopus Open Source License
// More information: http://xopus.org, info@xopus.org
// Mailing list: http://groups.yahoo.com/group/xopus
//
// This product includes software developed by Q42 BV (http://www.q42.nl/).
// please visit http://www.q42.nl for more information or mail us: xopus@q42.nl
//
////////////////////////////////////////////////////////////////////////////////////

function Xopus(id, theCanvas, theWindow) {
  try {
//1
//if (lon) return;
    this.id = id;
    this.canvas = theCanvas;
    this.window = theWindow;
    this.htmldocument = theWindow.document;
    this.basePath = this.htmldocument.location.pathname.substring(0, this.htmldocument.location.pathname.lastIndexOf('/')+1);
    this.view = null;
    this.hasChanged = false;
    this.curXML = null;
    this.newXML = null;


//1.5
//if (lon) return;


    //create a textarea, if not already
    this.textarea = theWindow.document.getElementById('xopus_textarea');
    if (!this.textarea) {
      var textarea = theWindow.document.createElement('textarea');
      textarea.id = 'xopus_textarea';
      textarea.style.position = (xopus_globs.browser.ie?'absolute':'fixed');
      textarea.style.top = '1px';
      textarea.style.right = '30px';
      textarea.style.width = '0px';
      textarea.style.height = '0px';
      textarea.style.border = 'none';
      this.textarea = theWindow.document.body.appendChild(textarea);
    }
//2
//if (lon) return;

    // Create the cache for this xopus
    this.cache = new CacheHandler();
//3
//if (lon) return;

    // Create tableeditor for this window
    if (!theWindow.xopus_tableeditor) theWindow.xopus_tableeditor = new TableEditor(theWindow);

    // Create pipeline
    var defXML = this.htmldocument.getElementsByTagName("xml")[0].XMLDocument;
    var pipelineDefinition = new PipelineDefinition(defXML, xopus_globs.datadriver, this.basePath);
    this.pipeline = new Pipeline(pipelineDefinition, xopus_globs.datadriver);
//4
//if (lon) return;

    // Initialize data handler
    this.xmlhandler = new XMLHandler(this, this.pipeline);

    // Store params
    this.dataURI   = pipelineDefinition.xmlURI;
    this.schemaURI = pipelineDefinition.xsdURI;

    // Load schema
    this.xmlhandler.loadSchema(this.schemaURI);
//5
//if (lon) return;

    // Load and enrich data
    this.data = this.xmlhandler.loadXML(this.dataURI);
    this.data = this.pipeline.enrichData(this.data);

    // Handle the document languages.
    var doclanguages = this.getDocumentLanguages();
    this.doclanguage = this.getDefaultDocumentLanguage(xopus_globs.locale.getLanguages(), doclanguages);
    this.addLanguage = xopus_globs.datadriver.loadXopusTemplate(xopus_globs.basePath + "xopusPlugins/add_lang.xsl");
    this.remLanguage = xopus_globs.datadriver.loadXopusTemplate(xopus_globs.basePath + "xopusPlugins/rem_lang.xsl");
    
    // Initialize the undo handler
    this.undohandler = new UndoHandler(this.data.cloneNode(true));

    // Change the view
    this.changeView(xopus_globs.lastView);

    //tell the UI we are ready
    xopus_globs.ui.ready();

    //set to not started if Xopus is in standby mode
    if (xopus_globs.isStandby) theCanvas.isStarted = false;

    // Show the toolbar if not yet visible
    if (!xopus_globs.xopusStarted && theCanvas.isStarted) {
      xopus_globs.set("xopusStarted", true);
    }
    
    //create a margin around the canvas
    this.canvas.style.padding = '1px';

    //do some special stuff if the canvas isn't started
    if (!theCanvas.isStarted) {
      this.disable();
    }

    //suscribe to a language change
    xopus_globs.subscribe('language', this, "applyLanguage" );

    //set focus to the window
    theWindow.focus();
  }
  catch (e)
  {
    var reason;
    if (e.getReason)
      reason = e.getReason("xopusCouldNotStart");
    else throw e;

    if (this.canvas)
      this.canvas.innerHTML = reason.replace(/\n/g, "<br>");
    else
      window.status = reason.replace(/\n/g, ' ');
  }
}

Xopus.prototype=
{
  destroy:function() {
    var curContext = Context.getCurrent();
    var prevContext = Context.getPrevious();

    //make sure no context (current nor previous nor cached) belongs to this xopus object
    if (curContext && (curContext.xopus == this)) {
      Context.currentXopus = null;
      Context.currentID = null;
    }
    if (prevContext && (prevContext.xopus == this)) Context.previousContext = null;
    if (Context.cachedContext && (Context.cachedContext.xopus == this)) Context.cachedContext = null;
    
    return true;
  },
  disable:function() {
    this.canvas.isStarted = false;
    xopus_globs.ui.redraw(this, true);

    if (this.canvas.isEditable) {
      this.canvas.title = xopus_globs.locale.getString('rightclicktoedit');
//LON TODO: redirect to eventCenter
      var theCanvas = this.canvas;
      this.mouseover_eventid = xopus_globs.framework.attachEvent(this.canvas, (xopus_globs.browser.ie?'onmouseenter':'onmouseover'), null, function(evt){var canvas=theCanvas; if (!canvas) return; canvas.style.padding='0px';canvas.style.border='dotted 1px blue';});
      this.mouseout_eventid = xopus_globs.framework.attachEvent(this.canvas, (xopus_globs.browser.ie?'onmouseleave':'onmouseout'), null, function(evt){var canvas=theCanvas; if (!canvas) return; canvas.style.padding='1px';canvas.style.border='none';});
      this.contextmenu_eventid = xopus_globs.framework.attachEvent(this.canvas, 'oncontextmenu', {
        startXopus:function(evt, params){
          var xopus = xopus_globs.xopi[params.id];
          xopus.enable();
          xopus_globs.framework.cancelEvent(evt);
        }}, 'startXopus', { id:this.id }
      );
    }
  },
  enable:function() {
    if (!this.canvas.isEditable) return;

    this.canvas.isStarted = true;
    xopus_globs.set("isStandby", false);
    this.canvas.title = '';
    this.canvas.style.padding = '1px';
    this.canvas.style.border = 'none';
    xopus_globs.framework.detachEvent(this.mouseover_eventid);
    xopus_globs.framework.detachEvent(this.mouseout_eventid);
    xopus_globs.framework.detachEvent(this.contextmenu_eventid);
    this.canvas.isStarted = true;
    if (!xopus_globs.xopusStarted) {
      xopus_globs.set("xopusStarted", true);
    }
    xopus_globs.ui.redraw(this, true);
  },
  
  /**
   * Render the new html
   */
  render: function() 
  {
    // Check if the current language still exists
    var langs = this.getDocumentLanguages();
    if (!langs[this.doclanguage])
      this.doclanguage = xopus_globs.utils.getAnyProperty(langs);
    
    var params = {lang: this.doclanguage};
    
    return this.pipeline.process(this.data, this.view, params);
  },

  // handlers

  /**
   * Store the changes in the value of the given editor.
   */
  handleChanges: function (editor, notUndoable, htmlElementTranslation)
  {
    var context = Context.getContext();
    if (!context || !context.hasChanged() || !editor.editable)
      return;
    
    // Get the current node.
    var node = context.getEditorNode();
    
    // Is the node empty?
    //if (editor.innerHTML == "" && node.specified)
    if (/^(\s|\u00A0)*$/.test(editor.innerText) && node.specified)
    {
      var nameNode = node;
      if (nameNode.nodeType == 3)
        nameNode = nameNode.parentNode;
      
      //editor.innerHTML = "[" + context.getPrettyName(nameNode.parentNode) + "]";
      xopus_globs.editorDriver.update(editor, context, "[" + context.getPrettyName(nameNode.parentNode) + "]");
      
      /*
      if (node.nodeType == 3 && node.parentNode.childNodes.length == 1)
        node = node.parentNode;

      this.xmlhandler.deleteNode(node);
      
      this.undohandler.addAction(UndoHandler.DELETE, this.data);
      */
    }
    
    // The node only exists in the schema (and is therefore a default attribute)
    if (!node.specified)
    {
      var parent = this.data.selectSingleNode(xpath + "/parent::*");
      var localname = xopus_globs.utils.getLocalName(node);
      var namespaceURI = node.namespaceURI;
      node = Context.getCurrent().createChildNode(parent, localname, namespaceURI);

      // The creation could have been cancelled by a schema extension handler.
      if (!node)
        return;

      parent.setAttributeNode(node);
    }
    
    /*var selElement = context.xopus.htmldocument.selection.createRange().parentElement();
    var editorHasSelection = (editor == selElement) || editor.contains(selElement);
    
    if (editorHasSelection) {
      xopus_globs.ui.storeSelection();

      // save previous text
      var textBefore = xopus_globs.utils.createTextRange(editor, 0, xopus_globs.ui.selStart).text;
      var textInside = xopus_globs.utils.createTextRange(editor, xopus_globs.ui.selStart, xopus_globs.ui.selStart+xopus_globs.ui.selLen).text;

      // and the word char only version
      var noSpaceCharsBefore = textBefore.replace(/\s|\u00A0/g,'');
      var noSpaceCharsInside = textInside.replace(/\s|\u00A0/g,'');
    }

    // Fix the dom. This results in a new HTML DOM!
    //editor.innerHTML = editor.innerHTML.replace(/<o:p><\/o:p>/g, "");
    xopus_globs.editorDriver.update(editor, context, editor.innerHTML.replace(/<o:p><\/o:p>/g, ""));

    if (editorHasSelection) {
      var rng = xopus_globs.utils.createTextRange(editor, 0, 0);
      var j=0;
      // expands rng one character, and returns this character
      function getChar() {
        var j=rng.text.length;
        while (!rng.text.charAt(j)) rng.moveEnd("character", 1);
        var c=rng.text.charAt(j);
        return c;
      }
      // match the word chars before the selection
      //for (var i=0; i<noSpaceCharsBefore.length; i++) 
      //  while (getChar()!=noSpaceCharsBefore.charAt(i)) {}
        
      rng.moveEnd("character", textBefore.length);
      var noSpaceCharsBeforeLen = noSpaceCharsBefore.length;
      var oldDiff=0;
      while (true)
      {
        var diff = noSpaceCharsBeforeLen - rng.text.replace(/\s|\u00A0/g,'').length;
        if (!diff||diff==oldDiff) break;
        rng.moveEnd("character", diff);
        oldDiff=diff;
      }

      if (noSpaceCharsInside)
      {
        // find next word char
        while (getChar()!=noSpaceCharsInside.charAt(0)) {}
        // and go one char back
        rng.moveEnd("character", -1); j--;
      }
*/
//      var rng2 = rng.duplicate();
      // add space chars 
//      rng2.moveEnd("character", -textInside.match(/^(\s|\u00A0)*/)[0].length);

/*      rng2.collapse(false);
      // rng2 has now the correct start point

      // match the word chars inside the selection
      //for (var i=0; i<noSpaceCharsInside.length; i++)
      //  while (getChar()!=noSpaceCharsInside.charAt(i)) {}

      rng.moveEnd("character", textInside.length);
      var noSpaceChars = noSpaceCharsBeforeLen + noSpaceCharsInside.length;
      var oldDiff=0;
      while (true)
      {
        var diff = noSpaceChars - rng.text.replace(/\s|\u00A0/g,'').length;
        if (!diff||diff==oldDiff) break;
        rng.moveEnd("character", diff);
        oldDiff=diff;
      }

      // add space chars 
      rng.moveEnd("character", textInside.match(/(\s|\u00A0)*$/)[0].length);

      rng2.setEndPoint("EndToEnd", rng);
      // rng2 has now the correct end point too

      rng2.select();
      xopus_globs.ui.storeSelection();
    }
*/
  
    // Get the new value.
    var defaultNamespace = xopus_globs.utils.getNamespaceForPrefix(node, "");
    var value = this.convertToXML(editor, defaultNamespace, htmlElementTranslation);

    switch (node.nodeType)
    {
      // Element
      case 1:
        xopus_globs.utils.removeChildren(node);

        var elt = value.selectSingleNode("*");

        if (elt && elt.nodeName == node.nodeName)
        {
          var newChildren = xopus_globs.utils.getChildren(elt);
          this.xmlhandler.appendNode(newChildren, node);

          // Add extra nodes created during typing.
          for (var i = 1; i < value.childNodes.length; i++)
            this.xmlhandler.insertNode(value.childNodes[i], node.parentNode, node);
        }
        else
        {
          this.xmlhandler.appendNode(value, node);
        }

        break;
      // Attribute.
      case 2:
        xopus_globs.utils.setAttributeValue(node, editor.innerText);
        break;
      // Text node.
      default:
        node.text = editor.innerText;
        break;
    }
    
    // Make the given node valid
    this.xmlhandler.makeValid(node);

    if (!notUndoable)
      this.undohandler.addAction(UndoHandler.TYPING, this.data);
  },

  /**
   * Convert the given html range to a DOM level 2 range.
   */
  convertRangeToXML: function (htmlDOM, xmlDOM, htmlRange)
  {
    //check whether there is a valid htmlDOM
    if (!htmlDOM) htmlDOM = htmlRange.parentElement();

    // Use the parent nodes if needed
    if (htmlDOM.nodeType == 3)
    {
      htmlDOM = htmlDOM.parentNode;
      if (xmlDOM.nodeType != 2)
        xmlDOM  = xmlDOM.parentNode;
    }
    
    // Create a new ieDOMRange
    var domRange = new ieDOMRange();
    //domRange.setStart(xmlDOM, 0);
    //domRange.setEnd(xmlDOM, (xmlDOM.nodeType == 3 && xmlDOM.nodeValue.length) || (xmlDOM.childNodes && xmlDOM.childNodes.length));
    
    // Find the start and end points
    var offsetRange = htmlRange.duplicate();
    offsetRange.moveToElementText(htmlDOM);
    offsetRange.setEndPoint("EndToStart", htmlRange);
    
    // Calc the number of word chars
    var startOffset = offsetRange.text.replace(/\s|\u00A0/g,'').length;
    var endOffset   = htmlRange.text.replace(/\s|\u00A0/g,'').length + startOffset;

    // range must start before the first char of htmlRange
    // not after the last char of offsetRange
    // @@Changed by Kars: if you click behind text but inside an editor, startOffset==endOffset. So, startOffset should not be incremented. (sept 23 2002)
    var startExtraOffset = 0;
    if (startOffset<endOffset) startExtraOffset=1;
    startOffset+=startExtraOffset;
    
    //__xopus_alert("offset: " + offsetRange.text.replace(/\s|\u00A0/g,'') + " len: " + htmlRange.text.replace(/\s|\u00A0/g,''));
    
    // Convert it
    for (var currOffset = 0; startOffset != -1 || endOffset != -1; xmlDOM = nextNode)
    {
      var nextNode = null;
      switch (xmlDOM.nodeType)
      {
        case 1:
        case 9:
        case 11:
          if (xmlDOM.childNodes.length != 0)
            nextNode = xmlDOM.childNodes[0];
          break;
        case 2:
        case 3:
          var text = xmlDOM.nodeValue;
          var len  = text.replace(/\s|\u00A0/g,'').length;

          // Found start point
          if (startOffset != -1 && currOffset <= startOffset && currOffset + len >= startOffset)
          {
            // Convert number of word chars to number of real chars
            //for (var i = startOffset - currOffset, j = 0; i > 0; j++)
            //  if (!/\s|\u00A0/.test(text.charAt(j))) 
            //    i--;
            
            //domRange.setStart(xmlDOM, j - 1);
            
            var count = startOffset - currOffset;
            var start = count;
            var diff;
            while (diff = count - text.substr(0, start).replace(/\s|\u00A0/g,'').length)
              start += diff;
              
            domRange.setStart(xmlDOM, start - startExtraOffset);
            
            startOffset = -1;
          }

          // Found end point
          if (endOffset != -1 && currOffset <= endOffset && currOffset + len >= endOffset)
          {
            // Convert number of word chars to number of real chars
            //for (var i = endOffset - currOffset, j = 0; i > 0; j++)
            //  if (!/\s|\u00A0/.test(text.charAt(j)))
            //    i--;

            //domRange.setEnd(xmlDOM, j);
            
            var count = endOffset - currOffset;
            var end = count;
            var diff;
            while (diff = count - text.substr(0, end).replace(/\s|\u00A0/g,'').length)
              end += diff;

            domRange.setEnd(xmlDOM, end);
            
            endOffset = -1;
          }

          currOffset += len;
          break;
        default:
          break;
      }

      if (!nextNode)
        nextNode = xmlDOM.selectSingleNode("following::node()");
    }
    
    if (!domRange.commonAncestorContainer)
    {
      __xopus_alert("currOffset: " + currOffset + " startOffset: " + startOffset + " endOffset: " + endOffset);
    }

    // Expand or reduce it over the adjacent whitespace
    this.reduceOrExpandOverWhitespace(domRange);

    // Normalize the range
    xopus_globs.utils.normalizeRange(domRange);
    
    // Return the precious result of our hard labour
    return domRange;
  },

  /**
   * Convert the _contents_ of the given html element to a XML document fragment.
   */
  convertToXML: function (htmlElt, defaultNamespace, htmlElementTranslation, recursive)
  {
    if (!recursive)
    {
      this.lastTextNode = null;
      recursive = true;
      
      var newElt = htmlElt.cloneNode(false);
      newElt.innerHTML = htmlElt.innerHTML;
      htmlElt = newElt;
    }
    
    var res = this.data.createDocumentFragment();

    var len = htmlElt.childNodes.length;
    for (var i = 0; i < len ; i++)
    {
      var htmlChild = htmlElt.childNodes[i];
      var xmlChild  = this.convertToXMLNode(htmlChild, defaultNamespace, htmlElementTranslation, recursive);
      
      if (xmlChild)
        res.appendChild(xmlChild);
    }

    return res;
  },

  /**
   * Convert the given html element to a XML node.
   */
  convertToXMLNode: function (htmlElt, defaultNamespace, htmlElementTranslation, recursive)
  {
    var res;

    switch (htmlElt.nodeType)
    {
      // Element
      case 1:
        try {
          if (htmlElt['__xopus:cache']&&htmlElt['__xopus:cache'].oldHTML==htmlElt.innerHTML)
            return htmlElt['__xopus:cache'].xml.cloneNode(true);
        } catch(e) {}
        
        var nodeName = htmlElt.nodeName.toLowerCase();
        if (htmlElementTranslation) 
          nodeName = htmlElementTranslation[nodeName] || nodeName;
        
        // TODO: This is incorrect behaviour: cannot convert to lowercase.
        // Skip garbage elements
        if (!/^[a-zA-Z_][a-zA-Z0-9_\-.]*$/.test(nodeName))
          res = this.data.createDocumentFragment();
        else if (defaultNamespace == null)
          res = this.data.createElement(nodeName);
        else
          res = this.data.createNode(1, nodeName, defaultNamespace);

        // Copy all attributes
        var len = htmlElt.attributes.length;
        for (var i =  0; i < len ; i++)
        {
          var attr = htmlElt.attributes[i];
          
          // The style attribute doesn't have a value in IE
          if (!attr.specified || !attr.nodeValue)
            continue;

          // Skip attributes in namespaces
          if (attr.nodeName.indexOf(":") != -1)
            continue;
          
          res.setAttribute(attr.nodeName, attr.nodeValue);
        }

        res.appendChild(this.convertToXML(htmlElt, defaultNamespace, htmlElementTranslation, recursive));
        
        htmlElt['__xopus:cache'] = {
          oldHTML:htmlElt.innerHTML,
          xml:res
        }
        
        break;
      // TextNode
      case 3:
        var val = htmlElt.nodeValue;
        if (this.lastTextNode && val.replace(/\s/g, "").length == 0)
          this.lastTextNode.appendData(val);
        else
        {
          res = this.data.createTextNode(val);
          this.lastTextNode = res;
        }
        break;
    }

    return res;
  },

  /**
   * Save the current XML.
   */
  save: function()
  {
    if (!xopus_globs.curHasChanged) return;

    var cleanData = this.pipeline.unrichData(this.data);

    if (laurens)
      xopus_globs.utils.debug("Saving:\n" + cleanData.xml);
    
    xopus_globs.datadriver.saveData(this.dataURI, cleanData);
  },

  /**
   * Perform an undo.
   */
  doUndo: function()
  {
    if (xopus_globs.browser.ie) 
      this.htmldocument.selection.empty();
    else 
      this.textarea.focus();
    
    // Restore data
    this.data = this.undohandler.undo();
    
    // Set buttons
    xopus_globs.set("toolbarDefinition.undo.items.undo.enabled", this.undohandler.canUndo());
    xopus_globs.set("toolbarDefinition.undo.items.redo.enabled", this.undohandler.canRedo());
    
    // Redraw
    xopus_globs.ui.redraw(this);
  },
  
  /**
   * Perform an redo.
   */
  doRedo: function()
  {
    // Restore data
    this.data = this.undohandler.redo();
    
    // Set buttons
    xopus_globs.set("toolbarDefinition.undo.items.undo.enabled", this.undohandler.canUndo());
    xopus_globs.set("toolbarDefinition.undo.items.redo.enabled", this.undohandler.canRedo());
    
    // Redraw
    xopus_globs.ui.redraw(this);
  },
  
  /**
   * Check if there is anything to undo.
   */
  canUndo: function()
  {
    return this.undohandler.canUndo();
  },
  
  /**
   * Check if there is anything to redo.
   */
  canRedo: function()
  {
    return this.undohandler.canRedo();
  },
  
  /**
   * Cut the current selection to the clipboard.
   */
  doCut: function()
  {
    if (xopus_globs.browser.ie) 
      this.htmldocument.execCommand('Cut', false);
  },
  
  /**
   * Copy the current selection to the clipboard.
   */
  doCopy: function()
  {
    if (xopus_globs.browser.ie) 
      this.htmldocument.execCommand('Copy', false);
  },
  
  /**
   * Paste to the current selection from the clipboard.
   */
  doPaste: function()
  {
    if (xopus_globs.browser.ie) 
      this.htmldocument.execCommand('Paste', false);
    
    //this.handleChanges(Context.getCurrent().getEditor(), true);
    //xopus_globs.ui.redraw(this);
  },
  
  /**
   * Paste the text to the current selection
   */
  doPlainTextPaste: function(text)
  {
    var context = Context.getCurrent();
    var data = context.xopus.data.createTextNode(text).xml;
    
    if (data.indexOf('\n')!=-1) {
      // insert <br>s and <p>s
      
      // remove \r's
      data=data.replace(/(\n\r|\r\n)/g,'\n');
      data=data.replace(/\r/g,'\n');

      //find the xml node belonging to the current editor
      var edNode = context.getEditorElement();

      //flag whether <p>'s and <br>'s are allowed
      var p_allowed = false;
      var br_allowed = false;

      //find all ancestors
      var ancestors = context.getAncestors();

      //loop all ancestors
      var startI = ancestors.length - 1;
      for (var i = startI; i>=0; i--) {
        var children = context.getPossibleChildren(ancestors[i]);

        if (children.p) {
          p_allowed = true;
          br_allowed = children.br;
          break;
        }

        //stop if the editor node has been reached
        if (ancestors[i] == edNode) break;
      }

      // insert <p>'s
      if (p_allowed) {
        data='<p>'+data+'</p>';
        data=data.replace(/\n\n/g, '</p><p>');
      }
      
      // insert <br>'s if they are allowed inside the <p> or the current node
      var posChildren = context.getPossibleChildren(context.getSelectionNode());
      if (posChildren.br||br_allowed) {
        data=data.replace(/\n/g, '<br />');
      }
    }
    
    var rng = this.htmldocument.selection.createRange();
    rng.pasteHTML(data);
  },

  /**
   * Insert or remove a node around the current selection.
   */
  insertNodeAround: function(nodes, mustInsert)
  {
    var context = Context.getCurrent();
    var editor  = context.getEditor();
    
    // Store the selection.
    xopus_globs.ui.storeSelection();
    
    // Store the changes first.
    this.handleChanges(editor);
    
    // Restore the selection
    xopus_globs.ui.restoreSelection();
    
    // Get a selection in the new DOM.
    var rng = this.htmldocument.selection.createRange();
    if (rng.text.length == 0)
      rng.expand("word");
    
    // Check if the range contains any non whitespace chars.
    if (rng.text.replace(/\s|\u00A0/g, "").length == 0)
      return false;
    
    // Get the current xml node.
    var editorNode = context.getEditorNode();
    
    // Check if the current html matches the current xml
    if (editorNode.nodeName.toLowerCase() != editor.childNodes[0].nodeName.toLowerCase())
    {
      //__xopus_alert(editor.outerHTML + "\n\n" + editorNode.xml);
      var domRange = this.convertRangeToXML(editor, editorNode, rng);
    }
    else
      var domRange = this.convertRangeToXML(editor.childNodes[0], editorNode, rng);
    
    var ancestor = this.findOneOfTheseAncestors(nodes, domRange.commonAncestorContainer);
    
    var selectionElt = domRange.commonAncestorContainer;
    if (selectionElt.nodeType == 3)
      selectionElt = selectionElt.parentNode;
    
    // The current node has an ancestor from the list
    if (ancestor != null)
    {
      if (mustInsert)
        return false;
      
      var children = xopus_globs.utils.getChildren(ancestor);
      var parent = ancestor.parentNode;
      this.xmlhandler.replaceNode(children, ancestor, parent);

      // Clean up XML.
      xopus_globs.utils.cleanupXML(parent);
      
      this.undohandler.addAction(UndoHandler.REMOVE, this.data);
    }
    else
    {
      var inserted = false;
      
      for (var n = selectionElt; !inserted && n != editorNode.parentNode; n = n.parentNode)
      {
        for (var i = 0; !inserted && i < nodes.length; i++)
        {
          if (context.canContainNode(n, nodes[i].name, nodes[i].namespace))
          {
            // Create the new node
            var node = context.createChildNode(n, nodes[i].name, nodes[i].namespace);

            // The creation could have been cancelled by a schema extension handler.
            if (!node)
              return false;

            var contents = domRange.cloneContents();
            domRange.commonAncestorContainer = n;
            domRange.deleteContents();
            contents = this.removeNodes(nodes, contents);

            // Insert the contents if possible, otherwise convert to text.
            if (this.xmlhandler.schemahandler.canInsertXML(node, contents, n))
              this.xmlhandler.insertXML(node, contents);
            else
              this.xmlhandler.insertXML(node, contents.ownerDocument.createTextNode(contents.text));

            domRange.insertNode(node);
            
            // Clean up XML.
            xopus_globs.utils.cleanupXML(n);
            this.pipeline.rerichData(n);
            
            // Store action in undo buffer
            this.undohandler.addAction(UndoHandler.INSERT, this.data);
            
            // Set flag
            inserted = true;
          }
        }
      }
      
      if (!inserted)
        return false;
    }

    // Redraw
    xopus_globs.ui.redraw(this);
    
    return true;
  },

  /**
   * Expands or reduces the given dom range over the adjacent whitespace to prevent unsignificant text nodes.
   */
  reduceOrExpandOverWhitespace: function (domRange)
  {
    
    if (domRange.startContainer.nodeType == 3)
    {
      var val = domRange.startContainer.nodeValue;

      if (/^(\s|\u00A0)*$/.test(val))
      {
        // the textnode only contains whitespace
        if (domRange.startContainer == domRange.endContainer)
        {
          // the whole range only contains whitespace
          domRange.startOffset = 0;
          domRange.endOffset = 0;
          return;
        }
        
        domRange.startOffset = val.length;
      }
      else
      {
        var i = domRange.startOffset;
        if (/^(\s|\u00A0)*$/.test(val.substr(0, i))) 
          // if the whitespace runs to the start of the textnode, expand
          domRange.startOffset = 0;
        else 
          // else reduce whitespace at the start
          domRange.startOffset += val.substr(i).match(/^(\s|\u00A0)*/)[0].length;
      }
      
      
    }

    if (domRange.endContainer.nodeType == 3)
    {
      var val = domRange.endContainer.nodeValue;
      var i = domRange.endOffset;
      if (/^(\s|\u00A0)*$/.test(val.substr(i))) 
        // if the whitespace runs to the end of the textnode, expand
        domRange.endOffset = val.length;
      else 
        // else reduce whitespace at the end
        domRange.endOffset -= val.substr(0,i).match(/(\s|\u00A0)*$/)[0].length;
    }

  },

  /**
   * Searches through all ancestors of node for a node in the nodes list.
   */
  findOneOfTheseAncestors: function (nodes, node)
  {
    if (node.nodeType == 3)
      node = node.parentNode;

    var ancestors = node.selectNodes("ancestor-or-self::*");
    for (var i = ancestors.length - 1; i >= 0; i--)
      for (var j = 0; j < nodes.length; j++)
        if (xopus_globs.utils.getLocalName(ancestors[i]) == nodes[j].name && 
            xopus_globs.utils.getNamespaceURI(ancestors[i]) == nodes[j].namespace)
          return ancestors[i];

    return null;
  },

  /**
   * Removes all occurences of all nodes in the nodes object from node.
   */
  removeNodes: function (nodes, node)
  {
    if (node.nodeType == 3)
      return node;

    var children;
    for (var i = 0; i < nodes.length; i++)
    {
      children = xopus_globs.utils.getChildren(node);

      for (var j = 0; j < children.childNodes.length; j++)
        children.replaceChild(this.removeNodes(nodes, children.childNodes[j]), children.childNodes[j]);

      if (xopus_globs.utils.getLocalName(node) == nodes[i].name &&
          xopus_globs.utils.getNamespaceURI(node) == nodes[i].namespace)
        return children;
    }

    return xopus_globs.utils.replaceChildren(node, children);
  },

  /**
   * Insert a new node in parentNode before the refNode.
   */
  insertNode: function(decl, parentNode, refNode)
  {
    // Get the context.
    var context = Context.getContext();
    
    var newNode = this.xmlhandler.createNode(decl, parentNode);
    var newName = context.getPrettyNameFromDeclaration(decl);
               
    // The creation could have been cancelled by a schema extension handler.
    if (!newNode)
      return;

    // If there is a selection, try to insert the new node around the selection.
    var rng = this.htmldocument.selection.createRange();
    
    if (rng.text.length == 0)
    {
      var pName = "[" + newName + "]";
      rng.text = pName;
      rng.moveStart("character", -pName.length);
      rng.select();
    }
    
    if (rng.text.length > 0 && this.insertNodeAround([{name: decl.name, namespace: decl.namespaceURI}], true))
      return;
    
    if (newNode.nodeType != 2)
    {
      // Ask whether before or after
      if (refNode == parentNode.firstChild &&
          this.xmlhandler.schemahandler.canInsertAfter(newNode, parentNode, refNode) &&
          this.xmlhandler.schemahandler.canInsertAfter(newNode, parentNode, null))
      {
        var xmlhnd  = this.xmlhandler;
        var xps     = this;
        var html    = xopus_globs.locale.getString("insertBefore", {newNode:newName, currNode:context.getPrettyName(refNode)});
        var before  = xopus_globs.locale.getString("before");
        var after   = xopus_globs.locale.getString("after");

        xopus_globs.dialog.show('alert', html, null, function()
          {
            // TODO: replace this by inserting placeholders
            // TODO: try inserting the selection here aswell
            xmlhnd.insertXML(newNode, newNode.ownerDocument.createTextNode("[" + newName + "]"));
            if (newNode.nodeName != "hr" && newNode.nodeName != "br")
            {
              var emptyNodes = newNode.selectNodes(".//*[not(node()) or (not(*) and (normalize-space()=''))]");
              for (var i = 0; i < emptyNodes.length; i++)
                emptyNodes[i].appendChild(newNode.ownerDocument.createTextNode("[" + newName + "]"));
            }
            xmlhnd.insertNode(newNode, parentNode, null);
            xps.undohandler.addAction(UndoHandler.INSERT, xps.data);
            xopus_globs.ui.redraw(xps);
          }, function()
          {
            // TODO: replace this by inserting placeholders
            // TODO: try inserting the selection here aswell
            xmlhnd.insertXML(newNode, newNode.ownerDocument.createTextNode("[" + newName + "]"));
            if (newNode.nodeName != "hr" && newNode.nodeName != "br")
            {
              var emptyNodes = newNode.selectNodes(".//*[not(node()) or (not(*) and (normalize-space()=''))]");
              for (var i = 0; i < emptyNodes.length; i++)
                emptyNodes[i].appendChild(newNode.ownerDocument.createTextNode("[" + newName + "]"));
            }
            
            xmlhnd.insertNode(newNode, parentNode, refNode);
            xps.undohandler.addAction(UndoHandler.INSERT, xps.data);
            xopus_globs.ui.redraw(xps);
          }, null, null, before, after, null, true, true);

        return;
      }
      
      // We couldn't prepend, so choose a refNode.
      if (!refNode)
        refNode = parentNode.firstChild;
      
      var searchNode = null;
      for (var n = refNode; !searchNode && n; n = n.nextSibling)
        if (this.xmlhandler.schemahandler.canInsertAfter(newNode, parentNode, n))
          searchNode = n;
      
      for (var n = refNode; !searchNode && n; n = n.previousSibling)
        if (this.xmlhandler.schemahandler.canInsertAfter(newNode, parentNode, n))
          searchNode = n;
    }
    
    if (newNode.nodeName != "hr" && newNode.nodeName != "br")
    {
      // If there is a selection, try to insert it into the new node.
      var rng = this.htmldocument.selection.createRange();
      var context = Context.getContext();
      if (rng.text.length != 0)
      {
        var currXML  = context.getEditorNode();
        var currHTML = context.getEditor();

        var domRange = this.convertRangeToXML(currHTML.childNodes[0], currXML, rng);
        var contents = domRange.extractContents();
        
        // if the selection makes the old element empty, put a placeholder
        if (currXML.xml=='') {
          var nameNode = currXML;
          if (nameNode.nodeType == 3)
            nameNode = nameNode.parentNode;

          currXML.text = "[" + context.getPrettyName(nameNode) + "]";
        }

        // Insert the selection if allowed, otherwise insert the text only.
        if (this.xmlhandler.schemahandler.canInsertXML(newNode, contents, parentNode))
          this.xmlhandler.insertXML(newNode, contents, parentNode);
        else
          this.xmlhandler.insertXML(newNode, contents.ownerDocument.createTextNode(contents.text), parentNode);

        // TODO: select contents of new node here
      }
      // TODO: replace this by inserting placeholders
      else
      {
        this.xmlhandler.insertXML(newNode, newNode.ownerDocument.createTextNode("[" + newName + "]"), parentNode);      
      }

      // TODO: replace this by inserting placeholders
      if (newNode.nodeType == 1)
      {
        var emptyNodes = newNode.selectNodes(".//*[not(node()) or (not(*) and (normalize-space()=''))]");
        for (var i = 0; i < emptyNodes.length; i++)
          emptyNodes[i].appendChild(newNode.ownerDocument.createTextNode("[" + newName + "]"));
      }
    }
    
    this.xmlhandler.insertNode(newNode, parentNode, searchNode);
    
    this.undohandler.addAction(UndoHandler.INSERT, this.data);
    
    xopus_globs.ui.redraw(this);
  },

  /**
   * Move the specified node up.
   */
  moveUp: function(node)
  {
    this.xmlhandler.moveUp(node);
    this.undohandler.addAction(UndoHandler.MOVEUP, this.data);
    
    xopus_globs.ui.redraw(this);
  },

  /**
   * Move the specified node down.
   */
  moveDown: function(node)
  {
    this.xmlhandler.moveDown(node);
    this.undohandler.addAction(UndoHandler.MOVEDOWN, this.data);
    
    xopus_globs.ui.redraw(this);
  },

  /**
   * Delete the given node.
   */
  deleteNode: function(node)
  {
    this.xmlhandler.deleteNode(node);
    this.undohandler.addAction(UndoHandler.DELETE, this.data);
    
    xopus_globs.ui.redraw(this);
  },

  /**
   * Get the given node.
   */
  getNode: function(xpath)
  {
    return this.data.selectSingleNode(xpath);
  },

  /**
   * Change the view
   */
  changeView: function (viewID) 
  {
    // Check the view
    if (!viewID || !this.pipeline.views[viewID]) 
      viewID = this.pipeline.defaultView.id;

    // Set the new view
    this.view = viewID;

    // Store the new view to be used as future default
    xopus_globs.store('lastView', viewID);

    // Store changes
    xopus_globs.ui.store();

    // Lose the current context
    Context.lose();

    // Redraw the canvas.
    xopus_globs.ui.redraw(this, true);
  },

  /**
   * Get the current view.
   */
  getCurrentView: function() {
    return this.view;
  },
  
  /**
   * Set the current document language.
   */
  setDocumentLanguage:function(lang) 
  {
    this.doclanguage = lang;

    // Store changes
    xopus_globs.ui.store();
    
    // Redraw the canvas.
    xopus_globs.ui.redraw(this);
  },
  
  /**
   * Add a document language.
   */
  addDocumentLanguage:function(newLang) 
  {
    // Store changes
    xopus_globs.ui.store();

    this.data = xopus_globs.xmllib.transform(this.data, this.addLanguage, {baseLang: this.doclanguage, newLang: newLang});
    this.data = this.pipeline.rerichData(this.data);
    
    this.doclanguage = newLang;
    
    // Update undo handler and buttons
    this.undohandler.addAction(UndoHandler.ADDLANG, this.data);
    xopus_globs.set("toolbarDefinition.undo.items.undo.enabled", this.undohandler.canUndo());
    xopus_globs.set("toolbarDefinition.undo.items.redo.enabled", this.undohandler.canRedo());
    
    // Redraw the canvas.
    xopus_globs.ui.redraw(this);
  },
  
  /**
   * Remove a document language.
   */
  remDocumentLanguage:function(oldLang) 
  {
    // Store changes
    xopus_globs.ui.store();

    this.data = xopus_globs.xmllib.transform(this.data, this.remLanguage, {remLang: oldLang});
    this.data = this.pipeline.rerichData(this.data);
    
    this.doclanguage = xopus_globs.utils.getAnyProperty(this.getDocumentLanguages());
    
    // Update undo handler and buttons
    this.undohandler.addAction(UndoHandler.REMLANG, this.data);
    xopus_globs.set("toolbarDefinition.undo.items.undo.enabled", this.undohandler.canUndo());
    xopus_globs.set("toolbarDefinition.undo.items.redo.enabled", this.undohandler.canRedo());
    
    // Redraw the canvas.
    xopus_globs.ui.redraw(this);
  },
  
  /** 
   * Get all languages currently available.
   */
  getDocumentLanguages: function ()
  {
    var attrs = this.data.selectNodes("//@*[local-name()='lang' and namespace-uri()='http://www.w3.org/XML/1998/namespace']");
    
    var langs = {};
    for (var i = 0; i < attrs.length; i++)
      langs[attrs[i].nodeValue] = true;
    
    return langs;
  },
  
  /**
   * Search the first array for the first languages that is in the second array. If none is, return the first element.
   */
  getDefaultDocumentLanguage: function (uiLangs, docLangs)
  {
    for (var lang in uiLangs)
      if (docLangs[lang])
        return lang;
    
    for (var lang in docLangs)
      return lang;
    
    // The document has no languages.
    return "";
  },
  applyLanguage:function() {
    this.canvas.title = xopus_globs.locale.getString('rightclicktoedit');
  },
  reload: function() {
    // Load and enrich data
    this.data = this.xmlhandler.loadXML(this.dataURI);
    this.data = this.pipeline.enrichData(this.data);

    //tell objects things have(n't) changed
    this.hasChanged = false;

    //redraw
    xopus_globs.ui.redraw(this, true);

    // Initialize the undo handler
    this.undohandler = new UndoHandler(this.data.cloneNode(true));

    //set the buttons accordingly
    xopus_globs.ui.setButtonState();
  }
};

numScriptsLoading--;

