<xsl:stylesheet xmlns:s="http://webplatform.rug.nl/_definition/shared/schemas/shared.xsd" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:param name="baseLang">nl</xsl:param>
  <xsl:param name="newLang">en</xsl:param>
  
  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>
  
  <xsl:template match="@*|*|text()"><xsl:copy><xsl:apply-templates select="@*|*|text()"/></xsl:copy></xsl:template>
  
  <xsl:template match="*[local-name()='xhtml' and namespace-uri()='http://webplatform.rug.nl/_definition/shared/schemas/shared.xsd']">
    <xsl:copy-of select="."/>
    <xsl:if test="lang($baseLang)">
      <s:xhtml xml:lang="{$newLang}" xmlns="http://www.w3.org/1999/xhtml">
        <div>[<xsl:value-of select="$newLang"/>]<xsl:value-of select="name(..)"/></div>
      </s:xhtml>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="*[local-name()='richText' and namespace-uri()='http://webplatform.rug.nl/_definition/shared/schemas/shared.xsd']">
    <xsl:copy-of select="."/>
    <xsl:if test="lang($baseLang)">
      <s:richText xml:lang="{$newLang}" xmlns="http://www.w3.org/1999/xhtml">
        <span>[<xsl:value-of select="$newLang"/>]<xsl:value-of select="name(..)"/></span>
      </s:richText>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="*[local-name()='text' and namespace-uri()='http://webplatform.rug.nl/_definition/shared/schemas/shared.xsd']">
    <xsl:copy-of select="."/>
    <xsl:if test="lang($baseLang)">
      <s:text xml:lang="{$newLang}" xmlns="http://www.w3.org/1999/xhtml">
        [<xsl:value-of select="$newLang"/>]<xsl:value-of select="name(..)"/>
      </s:text>
    </xsl:if>
  </xsl:template>
  
</xsl:stylesheet>