function Databasedriver()
{
  this.templatesLoaded = 0;
  this.schemasLoaded = 0;
  this.includesLoaded = 0;
}

Databasedriver.prototype={
  //
  // Xopus data (xml)
  //
  loadXopusData:function(name) {
    return xopus_globs.xmllib.load(name);
  },

  //
  // Xopus Templates
  //
  loadXopusTemplate:function(name) {
    this.templatesLoaded++;
    return { xsl: xopus_globs.xmllib.load(name), uri: name };
  },

  //
  // data (xml)
  //
  loadData:function(name) {
    return this.request_cms('open', 'xml', name, false);
    //return xopus_globs.xmllib.load(name);
  },

  saveData:function(name, doc) {
    this.saveWyona(name, doc, "checkin");


    // Note: save works (has enough permissions) if you use an .hta
    // and cannot save if you use a .html startup file.
/*
try
    {
      doc.save(name);
    }
    catch(e){}*/

  },

  //
  // Templates
  //
  loadTemplate:function(name) {
        this.templatesLoaded++;
        return { xsl: this.request_cms('open', 'xsl', name, false), uri: name };
  },

  //
  // Schema
  //
  loadSchema:function(name) {
      //this.schemasLoaded++;
      //return xopus_globs.xmllib.load(name);
      return this.request_cms('open', 'xsd', name, false);
  },

  //
  // XIncluded file
  //
  loadInclude:function(name) {
    this.includesLoaded++;
    return xopus_globs.xmllib.load(name);
  },

    // Specific Wyona code
    request_cms:function(requesttype, datatype, dataid, ignoreErrors, actualdata) {
      var d = new Date();

      var includestr = "";
      if (actualdata) {
        includestr = actualdata;
      }

      var reqxml=xopus_globs.objectFactory.createXMLDOM();
      var xmlhttp=xopus_globs.objectFactory.createXMLHttpRequest();
      var s='<request type="' + requesttype + '" id="req_' + dataid + '_' + d.getTime() + '"><data type="' + datatype + '" id="' + dataid + '">'+includestr+'</data></request>';
      reqxml.loadXML(s);

      //alert("databasedriver_wyona.js::request_cms:funtion(): POST xml: \n\n" + reqxml.xml);

      xmlhttp.open("POST", xopus_globs.WYONA_CMS_URL, false);
      xmlhttp.send(reqxml);

      reqxml.loadXML(xmlhttp.responseText);
      if (!reqxml.documentElement) {
          alert("databasedriver_wyona.js::request_cms:funtion(): Could not parse:\n\n"+xmlhttp.responseText);
          return null;
      }

  //alert("databasedriver_wyona.js::request_cms:funtion(): " + xopus_globs.WYONA_CMS_URL);

  // WYONA error handling
  try {
          //check the response status
          if (reqxml.selectSingleNode("/response/@status").nodeValue != "ok") {
            var errnr = reqxml.selectSingleNode("/response/error/@number").nodeValue;
            var errtitle = reqxml.selectSingleNode("/response/error/title").text;
            var errmsg = reqxml.selectSingleNode("/response/error/message").text;
            if (!ignoreErrors) alert("Error " + errnr + " from CMS server:\n\n" + errtitle + "\n" + errmsg);
            return null;
          }
        } catch (e) {
          if (!ignoreErrors) alert("databasedriver_wyona.js::request_cms:funtion(): Server returned an error, but was not understood by the editor.\n\n"+reqxml.xml);
          return null;
        }


      //return the data received as an XML DOM
      var result=xopus_globs.objectFactory.createXMLDOM();

      //if (reqxml.selectSingleNode("/response/@status").nodeValue == "ok" && requesttype == "checkin") {
      //    alert("databasedriver_wyona.js::request_cms:funtion(): Successfully saved: \n\n" + reqxml.xml);
      //}

      result.loadXML(reqxml.selectSingleNode("/response/data/*").xml);
      return result;
},

  saveWyona: function(name, doc, saveaction) {
  // default saveaction: is just 'save'.
  if (!saveaction) saveaction = "save";

  var resxml = this.request_cms(saveaction, "xml", name, false, doc.xml);
  //alert(resxml.xml);

  // quick hack to get a nice response from wyona CMS. remove later.
  var url=document.location.href.replace("/xopus2", "");
  document.location=url;
  return false;
}


};

numScriptsLoading--;
