/*
 *  Copyright (C) Chaperon. All rights reserved.                               
 *  ------------------------------------------------------------------------- 
 *  This software is published under the terms of the Apache Software License 
 *  version 1.1, a copy of which has been included  with this distribution in 
 *  the LICENSE file.                                                         
 */

package net.sourceforge.chaperon.parser.output;

import net.sourceforge.chaperon.parser.ParserTable;

/**
 * This class represents a listener, whch receives the event from the parser.
 *
 * @author Stephan Michels
 * @version CVS $Id: EventListener.java,v 1.1 2002/05/06 16:22:57 benedikta Exp $
 */
public interface EventListener
{
  public void startDocument(ParserTable table);

  public void startProduction(ParserTable table, int productionindex);

  public void startToken(ParserTable table, int tokenindex, char[] text, int textstart, int textlength);
  public void endToken(ParserTable table, int tokenindex);

  public void startIgnorableToken(ParserTable table, int ignorabletoken, char[] text, int textstart, int textlength);
  public void endIgnorableToken(ParserTable table, int ignorabletoken);

  public void endProduction(ParserTable table, int productionindex);  

  public void endDocument(ParserTable table);
}
